/*! Built with IMPACT - impactjs.com */

(function(window){"use strict";Number.prototype.map=function(istart,istop,ostart,ostop){return ostart+(ostop-ostart)*((this-istart)/(istop-istart));};Number.prototype.limit=function(min,max){return Math.min(max,Math.max(min,this));};Number.prototype.round=function(precision){precision=Math.pow(10,precision||0);return Math.round(this*precision)/precision;};Number.prototype.floor=function(){return Math.floor(this);};Number.prototype.ceil=function(){return Math.ceil(this);};Number.prototype.toInt=function(){return(this|0);};Number.prototype.toRad=function(){return(this/180)*Math.PI;};Number.prototype.toDeg=function(){return(this*180)/Math.PI;};Object.defineProperty(Array.prototype,'erase',{value:function(item){for(var i=this.length;i--;){if(this[i]===item){this.splice(i,1);}}
return this;}});Object.defineProperty(Array.prototype,'random',{value:function(item){return this[Math.floor(Math.random()*this.length)];}});Function.prototype.bind=Function.prototype.bind||function(oThis){if(typeof this!=="function"){throw new TypeError("Function.prototype.bind - what is trying to be bound is not callable");}
var aArgs=Array.prototype.slice.call(arguments,1),fToBind=this,fNOP=function(){},fBound=function(){return fToBind.apply((this instanceof fNOP&&oThis?this:oThis),aArgs.concat(Array.prototype.slice.call(arguments)));};fNOP.prototype=this.prototype;fBound.prototype=new fNOP();return fBound;};window.ig={game:null,debug:null,version:'1.23',global:window,modules:{},resources:[],ready:false,baked:false,nocache:'',ua:{},prefix:(window.ImpactPrefix||''),lib:'lib/',_current:null,_loadQueue:[],_waitForOnload:0,$:function(selector){return selector.charAt(0)=='#'?document.getElementById(selector.substr(1)):document.getElementsByTagName(selector);},$new:function(name){return document.createElement(name);},copy:function(object){if(!object||typeof(object)!='object'||object instanceof HTMLElement||object instanceof ig.Class){return object;}
else if(object instanceof Array){var c=[];for(var i=0,l=object.length;i<l;i++){c[i]=ig.copy(object[i]);}
return c;}
else{var c={};for(var i in object){c[i]=ig.copy(object[i]);}
return c;}},merge:function(original,extended){for(var key in extended){var ext=extended[key];if(typeof(ext)!='object'||ext instanceof HTMLElement||ext instanceof ig.Class||ext===null){original[key]=ext;}
else{if(!original[key]||typeof(original[key])!='object'){original[key]=(ext instanceof Array)?[]:{};}
ig.merge(original[key],ext);}}
return original;},ksort:function(obj){if(!obj||typeof(obj)!='object'){return[];}
var keys=[],values=[];for(var i in obj){keys.push(i);}
keys.sort();for(var i=0;i<keys.length;i++){values.push(obj[keys[i]]);}
return values;},setVendorAttribute:function(el,attr,val){var uc=attr.charAt(0).toUpperCase()+attr.substr(1);el[attr]=el['ms'+uc]=el['moz'+uc]=el['webkit'+uc]=el['o'+uc]=val;},getVendorAttribute:function(el,attr){var uc=attr.charAt(0).toUpperCase()+attr.substr(1);return el[attr]||el['ms'+uc]||el['moz'+uc]||el['webkit'+uc]||el['o'+uc];},normalizeVendorAttribute:function(el,attr){var prefixedVal=ig.getVendorAttribute(el,attr);if(!el[attr]&&prefixedVal){el[attr]=prefixedVal;}},getImagePixels:function(image,x,y,width,height){var canvas=ig.$new('canvas');canvas.width=image.width;canvas.height=image.height;var ctx=canvas.getContext('2d');ig.System.SCALE.CRISP(canvas,ctx);var ratio=ig.getVendorAttribute(ctx,'backingStorePixelRatio')||1;ig.normalizeVendorAttribute(ctx,'getImageDataHD');var realWidth=image.width/ratio,realHeight=image.height/ratio;canvas.width=Math.ceil(realWidth);canvas.height=Math.ceil(realHeight);ctx.drawImage(image,0,0,realWidth,realHeight);return(ratio===1)?ctx.getImageData(x,y,width,height):ctx.getImageDataHD(x,y,width,height);},module:function(name){if(ig._current){throw("Module '"+ig._current.name+"' defines nothing");}
if(ig.modules[name]&&ig.modules[name].body){throw("Module '"+name+"' is already defined");}
ig._current={name:name,requires:[],loaded:false,body:null};ig.modules[name]=ig._current;ig._loadQueue.push(ig._current);return ig;},requires:function(){ig._current.requires=Array.prototype.slice.call(arguments);return ig;},defines:function(body){ig._current.body=body;ig._current=null;ig._initDOMReady();},addResource:function(resource){ig.resources.push(resource);},setNocache:function(set){ig.nocache=set?'?'+Date.now():'';},log:function(){},assert:function(condition,msg){},show:function(name,number){},mark:function(msg,color){},_loadScript:function(name,requiredFrom){ig.modules[name]={name:name,requires:[],loaded:false,body:null};ig._waitForOnload++;var path=ig.prefix+ig.lib+name.replace(/\./g,'/')+'.js'+ig.nocache;var script=ig.$new('script');script.type='text/javascript';script.src=path;script.onload=function(){ig._waitForOnload--;ig._execModules();};script.onerror=function(){throw('Failed to load module '+name+' at '+path+' '+'required from '+requiredFrom);};ig.$('head')[0].appendChild(script);},_execModules:function(){var modulesLoaded=false;for(var i=0;i<ig._loadQueue.length;i++){var m=ig._loadQueue[i];var dependenciesLoaded=true;for(var j=0;j<m.requires.length;j++){var name=m.requires[j];if(!ig.modules[name]){dependenciesLoaded=false;ig._loadScript(name,m.name);}
else if(!ig.modules[name].loaded){dependenciesLoaded=false;}}
if(dependenciesLoaded&&m.body){ig._loadQueue.splice(i,1);m.loaded=true;m.body();modulesLoaded=true;i--;}}
if(modulesLoaded){ig._execModules();}
else if(!ig.baked&&ig._waitForOnload==0&&ig._loadQueue.length!=0){var unresolved=[];for(var i=0;i<ig._loadQueue.length;i++){var unloaded=[];var requires=ig._loadQueue[i].requires;for(var j=0;j<requires.length;j++){var m=ig.modules[requires[j]];if(!m||!m.loaded){unloaded.push(requires[j]);}}
unresolved.push(ig._loadQueue[i].name+' (requires: '+unloaded.join(', ')+')');}
throw("Unresolved (or circular?) dependencies. "+"Most likely there's a name/path mismatch for one of the listed modules "+"or a previous syntax error prevents a module from loading:\n"+
unresolved.join('\n'));}},_DOMReady:function(){if(!ig.modules['dom.ready'].loaded){if(!document.body){return setTimeout(ig._DOMReady,13);}
ig.modules['dom.ready'].loaded=true;ig._waitForOnload--;ig._execModules();}
return 0;},_boot:function(){if(document.location.href.match(/\?nocache/)){ig.setNocache(true);}
ig.ua.pixelRatio=window.devicePixelRatio||1;ig.ua.viewport={width:window.innerWidth,height:window.innerHeight};ig.ua.screen={width:window.screen.availWidth*ig.ua.pixelRatio,height:window.screen.availHeight*ig.ua.pixelRatio};ig.ua.iPhone=/iPhone/i.test(navigator.userAgent);ig.ua.iPhone4=(ig.ua.iPhone&&ig.ua.pixelRatio==2);ig.ua.iPad=/iPad/i.test(navigator.userAgent);ig.ua.android=/android/i.test(navigator.userAgent);ig.ua.winPhone=/Windows Phone/i.test(navigator.userAgent);ig.ua.iOS=ig.ua.iPhone||ig.ua.iPad;ig.ua.mobile=ig.ua.iOS||ig.ua.android||ig.ua.winPhone||/mobile/i.test(navigator.userAgent);ig.ua.touchDevice=(('ontouchstart'in window)||(window.navigator.msMaxTouchPoints));},_initDOMReady:function(){if(ig.modules['dom.ready']){ig._execModules();return;}
ig._boot();ig.modules['dom.ready']={requires:[],loaded:false,body:null};ig._waitForOnload++;if(document.readyState==='complete'){ig._DOMReady();}
else{document.addEventListener('DOMContentLoaded',ig._DOMReady,false);window.addEventListener('load',ig._DOMReady,false);}}};ig.normalizeVendorAttribute(window,'requestAnimationFrame');if(window.requestAnimationFrame){var next=1,anims={};window.ig.setAnimation=function(callback,element){var current=next++;anims[current]=true;var animate=function(){if(!anims[current]){return;}
window.requestAnimationFrame(animate,element);callback();};window.requestAnimationFrame(animate,element);return current;};window.ig.clearAnimation=function(id){delete anims[id];};}
else{window.ig.setAnimation=function(callback,element){return window.setInterval(callback,1000/60);};window.ig.clearAnimation=function(id){window.clearInterval(id);};}
var initializing=false,fnTest=/xyz/.test(function(){xyz;})?/\bparent\b/:/.*/;var lastClassId=0;window.ig.Class=function(){};var inject=function(prop){var proto=this.prototype;var parent={};for(var name in prop){if(typeof(prop[name])=="function"&&typeof(proto[name])=="function"&&fnTest.test(prop[name])){parent[name]=proto[name];proto[name]=(function(name,fn){return function(){var tmp=this.parent;this.parent=parent[name];var ret=fn.apply(this,arguments);this.parent=tmp;return ret;};})(name,prop[name]);}
else{proto[name]=prop[name];}}};window.ig.Class.extend=function(prop){var parent=this.prototype;initializing=true;var prototype=new this();initializing=false;for(var name in prop){if(typeof(prop[name])=="function"&&typeof(parent[name])=="function"&&fnTest.test(prop[name])){prototype[name]=(function(name,fn){return function(){var tmp=this.parent;this.parent=parent[name];var ret=fn.apply(this,arguments);this.parent=tmp;return ret;};})(name,prop[name]);}
else{prototype[name]=prop[name];}}
function Class(){if(!initializing){if(this.staticInstantiate){var obj=this.staticInstantiate.apply(this,arguments);if(obj){return obj;}}
for(var p in this){if(typeof(this[p])=='object'){this[p]=ig.copy(this[p]);}}
if(this.init){this.init.apply(this,arguments);}}
return this;}
Class.prototype=prototype;Class.prototype.constructor=Class;Class.extend=window.ig.Class.extend;Class.inject=inject;Class.classId=prototype.classId=++lastClassId;return Class;};if(window.ImpactMixin){ig.merge(ig,window.ImpactMixin);}})(window);

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/impact/image.js
ig.baked=true;ig.module('impact.image').defines(function(){"use strict";ig.Image=ig.Class.extend({data:null,width:0,height:0,loaded:false,failed:false,loadCallback:null,path:'',staticInstantiate:function(path){return ig.Image.cache[path]||null;},init:function(path){this.path=path;this.load();},load:function(loadCallback){if(this.loaded){if(loadCallback){loadCallback(this.path,true);}
return;}
else if(!this.loaded&&ig.ready){this.loadCallback=loadCallback||null;this.data=new Image();this.data.onload=this.onload.bind(this);this.data.onerror=this.onerror.bind(this);this.data.src=ig.prefix+this.path+ig.nocache;}
else{ig.addResource(this);}
ig.Image.cache[this.path]=this;},reload:function(){this.loaded=false;this.data=new Image();this.data.onload=this.onload.bind(this);this.data.src=this.path+'?'+Date.now();},onload:function(event){this.width=this.data.width;this.height=this.data.height;this.loaded=true;if(ig.system.scale!=1){this.resize(ig.system.scale);}
if(this.loadCallback){this.loadCallback(this.path,true);}},onerror:function(event){this.failed=true;if(this.loadCallback){this.loadCallback(this.path,false);}},resize:function(scale){var origPixels=ig.getImagePixels(this.data,0,0,this.width,this.height);var widthScaled=this.width*scale;var heightScaled=this.height*scale;var scaled=ig.$new('canvas');scaled.width=widthScaled;scaled.height=heightScaled;var scaledCtx=scaled.getContext('2d');var scaledPixels=scaledCtx.getImageData(0,0,widthScaled,heightScaled);for(var y=0;y<heightScaled;y++){for(var x=0;x<widthScaled;x++){var index=(Math.floor(y/scale)*this.width+Math.floor(x/scale))*4;var indexScaled=(y*widthScaled+x)*4;scaledPixels.data[indexScaled]=origPixels.data[index];scaledPixels.data[indexScaled+1]=origPixels.data[index+1];scaledPixels.data[indexScaled+2]=origPixels.data[index+2];scaledPixels.data[indexScaled+3]=origPixels.data[index+3];}}
scaledCtx.putImageData(scaledPixels,0,0);this.data=scaled;},draw:function(targetX,targetY,sourceX,sourceY,width,height){if(!this.loaded){return;}
var scale=ig.system.scale;sourceX=sourceX?sourceX*scale:0;sourceY=sourceY?sourceY*scale:0;width=(width?width:this.width)*scale;height=(height?height:this.height)*scale;ig.system.context.drawImage(this.data,sourceX,sourceY,width,height,ig.system.getDrawPos(targetX),ig.system.getDrawPos(targetY),width,height);ig.Image.drawCount++;},drawTile:function(targetX,targetY,tile,tileWidth,tileHeight,flipX,flipY){tileHeight=tileHeight?tileHeight:tileWidth;if(!this.loaded||tileWidth>this.width||tileHeight>this.height){return;}
var scale=ig.system.scale;var tileWidthScaled=Math.floor(tileWidth*scale);var tileHeightScaled=Math.floor(tileHeight*scale);var scaleX=flipX?-1:1;var scaleY=flipY?-1:1;if(flipX||flipY){ig.system.context.save();ig.system.context.scale(scaleX,scaleY);}
ig.system.context.drawImage(this.data,(Math.floor(tile*tileWidth)%this.width)*scale,(Math.floor(tile*tileWidth/this.width)*tileHeight)*scale,tileWidthScaled,tileHeightScaled,ig.system.getDrawPos(targetX)*scaleX-(flipX?tileWidthScaled:0),ig.system.getDrawPos(targetY)*scaleY-(flipY?tileHeightScaled:0),tileWidthScaled,tileHeightScaled);if(flipX||flipY){ig.system.context.restore();}
ig.Image.drawCount++;}});ig.Image.drawCount=0;ig.Image.cache={};ig.Image.reloadCache=function(){for(var path in ig.Image.cache){ig.Image.cache[path].reload();}};});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/impact/font.js
ig.baked=true;ig.module('impact.font').requires('impact.image').defines(function(){"use strict";ig.Font=ig.Image.extend({widthMap:[],indices:[],firstChar:32,alpha:1,letterSpacing:1,lineSpacing:0,onload:function(ev){this._loadMetrics(this.data);this.parent(ev);},widthForString:function(text){if(text.indexOf('\n')!==-1){var lines=text.split('\n');var width=0;for(var i=0;i<lines.length;i++){width=Math.max(width,this._widthForLine(lines[i]));}
return width;}
else{return this._widthForLine(text);}},_widthForLine:function(text){var width=0;for(var i=0;i<text.length;i++){width+=this.widthMap[text.charCodeAt(i)-this.firstChar]+this.letterSpacing;}
return width;},heightForString:function(text){return text.split('\n').length*(this.height+this.lineSpacing);},draw:function(text,x,y,align){if(typeof(text)!='string'){text=text.toString();}
if(text.indexOf('\n')!==-1){var lines=text.split('\n');var lineHeight=this.height+this.lineSpacing;for(var i=0;i<lines.length;i++){this.draw(lines[i],x,y+i*lineHeight,align);}
return;}
if(align==ig.Font.ALIGN.RIGHT||align==ig.Font.ALIGN.CENTER){var width=this._widthForLine(text);x-=align==ig.Font.ALIGN.CENTER?width/2:width;}
if(this.alpha!==1){ig.system.context.globalAlpha=this.alpha;}
for(var i=0;i<text.length;i++){var c=text.charCodeAt(i);x+=this._drawChar(c-this.firstChar,x,y);}
if(this.alpha!==1){ig.system.context.globalAlpha=1;}
ig.Image.drawCount+=text.length;},_drawChar:function(c,targetX,targetY){if(!this.loaded||c<0||c>=this.indices.length){return 0;}
var scale=ig.system.scale;var charX=this.indices[c]*scale;var charY=0;var charWidth=this.widthMap[c]*scale;var charHeight=(this.height-2)*scale;ig.system.context.drawImage(this.data,charX,charY,charWidth,charHeight,ig.system.getDrawPos(targetX),ig.system.getDrawPos(targetY),charWidth,charHeight);return this.widthMap[c]+this.letterSpacing;},_loadMetrics:function(image){this.height=image.height-1;this.widthMap=[];this.indices=[];var px=ig.getImagePixels(image,0,image.height-1,image.width,1);var currentChar=0;var currentWidth=0;for(var x=0;x<image.width;x++){var index=x*4+3;if(px.data[index]>127){currentWidth++;}
else if(px.data[index]<128&&currentWidth){this.widthMap.push(currentWidth);this.indices.push(x-currentWidth);currentChar++;currentWidth=0;}}
this.widthMap.push(currentWidth);this.indices.push(x-currentWidth);}});ig.Font.ALIGN={LEFT:0,RIGHT:1,CENTER:2};});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/impact/sound.js
ig.baked=true;ig.module('impact.sound').defines(function(){"use strict";ig.SoundManager=ig.Class.extend({clips:{},volume:1,format:null,init:function(){if(!ig.Sound.enabled||!window.Audio){ig.Sound.enabled=false;return;}
var probe=new Audio();for(var i=0;i<ig.Sound.use.length;i++){var format=ig.Sound.use[i];if(probe.canPlayType(format.mime)){this.format=format;break;}}
if(!this.format){ig.Sound.enabled=false;}
if(ig.Sound.enabled&&ig.Sound.useWebAudio){this.audioContext=new AudioContext();}},load:function(path,multiChannel,loadCallback){if(multiChannel&&ig.Sound.useWebAudio){return this.loadWebAudio(path,multiChannel,loadCallback);}
else{return this.loadHTML5Audio(path,multiChannel,loadCallback);}},loadWebAudio:function(path,multiChannel,loadCallback){var realPath=ig.prefix+path.replace(/[^\.]+$/,this.format.ext)+ig.nocache;if(this.clips[path]){return this.clips[path];}
var audioSource=new ig.Sound.WebAudioSource()
this.clips[path]=audioSource;var request=new XMLHttpRequest();request.open('GET',realPath,true);request.responseType='arraybuffer';var that=this;request.onload=function(ev){that.audioContext.decodeAudioData(request.response,function(buffer){audioSource.buffer=buffer;loadCallback(path,true,ev);},function(ev){loadCallback(path,false,ev);});};request.onerror=function(ev){loadCallback(path,false,ev);};request.send();return audioSource;},loadHTML5Audio:function(path,multiChannel,loadCallback){var realPath=ig.prefix+path.replace(/[^\.]+$/,this.format.ext)+ig.nocache;if(this.clips[path]){if(this.clips[path]instanceof ig.Sound.WebAudioSource){return this.clips[path];}
if(multiChannel&&this.clips[path].length<ig.Sound.channels){for(var i=this.clips[path].length;i<ig.Sound.channels;i++){var a=new Audio(realPath);a.load();this.clips[path].push(a);}}
return this.clips[path][0];}
var clip=new Audio(realPath);if(loadCallback){clip.addEventListener('canplaythrough',function cb(ev){clip.removeEventListener('canplaythrough',cb,false);loadCallback(path,true,ev);},false);clip.addEventListener('error',function(ev){loadCallback(path,false,ev);},false);}
clip.preload='auto';clip.load();this.clips[path]=[clip];if(multiChannel){for(var i=1;i<ig.Sound.channels;i++){var a=new Audio(realPath);a.load();this.clips[path].push(a);}}
return clip;},get:function(path){var channels=this.clips[path];if(channels&&channels instanceof ig.Sound.WebAudioSource){return channels;}
for(var i=0,clip;clip=channels[i++];){if(clip.paused||clip.ended){if(clip.ended){clip.currentTime=0;}
return clip;}}
channels[0].pause();channels[0].currentTime=0;return channels[0];}});ig.Music=ig.Class.extend({tracks:[],namedTracks:{},currentTrack:null,currentIndex:0,random:false,_volume:1,_loop:false,_fadeInterval:0,_fadeTimer:null,_endedCallbackBound:null,init:function(){this._endedCallbackBound=this._endedCallback.bind(this);Object.defineProperty(this,"volume",{get:this.getVolume.bind(this),set:this.setVolume.bind(this)});Object.defineProperty(this,"loop",{get:this.getLooping.bind(this),set:this.setLooping.bind(this)});},add:function(music,name){if(!ig.Sound.enabled){return;}
var path=music instanceof ig.Sound?music.path:music;var track=ig.soundManager.load(path,false);if(track instanceof ig.Sound.WebAudioSource){ig.system.stopRunLoop();throw("Sound '"+path+"' loaded as Multichannel but used for Music. "+"Set the multiChannel param to false when loading, e.g.: new ig.Sound(path, false)");}
track.loop=this._loop;track.volume=this._volume;track.addEventListener('ended',this._endedCallbackBound,false);this.tracks.push(track);if(name){this.namedTracks[name]=track;}
if(!this.currentTrack){this.currentTrack=track;}},next:function(){if(!this.tracks.length){return;}
this.stop();this.currentIndex=this.random?Math.floor(Math.random()*this.tracks.length):(this.currentIndex+1)%this.tracks.length;this.currentTrack=this.tracks[this.currentIndex];this.play();},pause:function(){if(!this.currentTrack){return;}
this.currentTrack.pause();},stop:function(){if(!this.currentTrack){return;}
this.currentTrack.pause();this.currentTrack.currentTime=0;},play:function(name){if(name&&this.namedTracks[name]){var newTrack=this.namedTracks[name];if(newTrack!=this.currentTrack){this.stop();this.currentTrack=newTrack;}}
else if(!this.currentTrack){return;}
this.currentTrack.play();},getLooping:function(){return this._loop;},setLooping:function(l){this._loop=l;for(var i in this.tracks){this.tracks[i].loop=l;}},getVolume:function(){return this._volume;},setVolume:function(v){this._volume=v.limit(0,1);for(var i in this.tracks){this.tracks[i].volume=this._volume;}},fadeOut:function(time){if(!this.currentTrack){return;}
clearInterval(this._fadeInterval);this.fadeTimer=new ig.Timer(time);this._fadeInterval=setInterval(this._fadeStep.bind(this),50);},_fadeStep:function(){var v=this.fadeTimer.delta().map(-this.fadeTimer.target,0,1,0).limit(0,1)*this._volume;if(v<=0.01){this.stop();this.currentTrack.volume=this._volume;clearInterval(this._fadeInterval);}
else{this.currentTrack.volume=v;}},_endedCallback:function(){if(this._loop){this.play();}
else{this.next();}}});ig.Sound=ig.Class.extend({path:'',volume:1,currentClip:null,multiChannel:true,_loop:false,init:function(path,multiChannel){this.path=path;this.multiChannel=(multiChannel!==false);Object.defineProperty(this,"loop",{get:this.getLooping.bind(this),set:this.setLooping.bind(this)});this.load();},getLooping:function(){return this._loop;},setLooping:function(loop){this._loop=loop;if(this.currentClip){this.currentClip.loop=loop;}},load:function(loadCallback){if(!ig.Sound.enabled){if(loadCallback){loadCallback(this.path,true);}
return;}
if(ig.ready){ig.soundManager.load(this.path,this.multiChannel,loadCallback);}
else{ig.addResource(this);}},play:function(){if(!ig.Sound.enabled){return;}
this.currentClip=ig.soundManager.get(this.path);this.currentClip.loop=this._loop;this.currentClip.volume=ig.soundManager.volume*this.volume;this.currentClip.play();},stop:function(){if(this.currentClip){this.currentClip.pause();this.currentClip.currentTime=0;}}});ig.Sound.WebAudioSource=ig.Class.extend({sources:[],gain:null,buffer:null,_loop:false,init:function(){this.gain=ig.soundManager.audioContext.createGain();this.gain.connect(ig.soundManager.audioContext.destination);Object.defineProperty(this,"loop",{get:this.getLooping.bind(this),set:this.setLooping.bind(this)});Object.defineProperty(this,"volume",{get:this.getVolume.bind(this),set:this.setVolume.bind(this)});},play:function(){if(!this.buffer){return;}
var source=ig.soundManager.audioContext.createBufferSource();source.buffer=this.buffer;source.connect(this.gain);source.loop=this._loop;var that=this;this.sources.push(source);source.onended=function(){that.sources.erase(source);}
source.start(0);},pause:function(){for(var i=0;i<this.sources.length;i++){try{this.sources[i].stop();}catch(err){}}},getLooping:function(){return this._loop;},setLooping:function(loop){this._loop=loop;for(var i=0;i<this.sources.length;i++){this.sources[i].loop=loop;}},getVolume:function(){return this.gain.gain.value;},setVolume:function(volume){this.gain.gain.value=volume;}});ig.Sound.FORMAT={MP3:{ext:'mp3',mime:'audio/mpeg'},M4A:{ext:'m4a',mime:'audio/mp4; codecs=mp4a'},OGG:{ext:'ogg',mime:'audio/ogg; codecs=vorbis'},WEBM:{ext:'webm',mime:'audio/webm; codecs=vorbis'},CAF:{ext:'caf',mime:'audio/x-caf'}};ig.Sound.use=[ig.Sound.FORMAT.OGG,ig.Sound.FORMAT.MP3];ig.Sound.channels=4;ig.Sound.enabled=true;ig.normalizeVendorAttribute(window,'AudioContext');ig.Sound.useWebAudio=!!window.AudioContext;});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/impact/loader.js
ig.baked=true;ig.module('impact.loader').requires('impact.image','impact.font','impact.sound').defines(function(){"use strict";ig.Loader=ig.Class.extend({resources:[],gameClass:null,status:0,done:false,_unloaded:[],_drawStatus:0,_intervalId:0,_loadCallbackBound:null,init:function(gameClass,resources){this.gameClass=gameClass;this.resources=resources;this._loadCallbackBound=this._loadCallback.bind(this);for(var i=0;i<this.resources.length;i++){this._unloaded.push(this.resources[i].path);}},load:function(){ig.system.clear('#000');if(!this.resources.length){this.end();return;}
for(var i=0;i<this.resources.length;i++){this.loadResource(this.resources[i]);}
this._intervalId=setInterval(this.draw.bind(this),16);},loadResource:function(res){res.load(this._loadCallbackBound);},end:function(){if(this.done){return;}
this.done=true;clearInterval(this._intervalId);ig.system.setGame(this.gameClass);},draw:function(){this._drawStatus+=(this.status-this._drawStatus)/5;var s=ig.system.scale;var w=ig.system.width*0.6;var h=ig.system.height*0.1;var x=ig.system.width*0.5-w/2;var y=ig.system.height*0.5-h/2;ig.system.context.fillStyle='#000';ig.system.context.fillRect(0,0,480,320);ig.system.context.fillStyle='#fff';ig.system.context.fillRect(x*s,y*s,w*s,h*s);ig.system.context.fillStyle='#000';ig.system.context.fillRect(x*s+s,y*s+s,w*s-s-s,h*s-s-s);ig.system.context.fillStyle='#fff';ig.system.context.fillRect(x*s,y*s,w*s*this._drawStatus,h*s);},_loadCallback:function(path,status){if(status){this._unloaded.erase(path);}
else{throw('Failed to load resource: '+path);}
this.status=1-(this._unloaded.length/this.resources.length);if(this._unloaded.length==0){setTimeout(this.end.bind(this),250);}}});});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/impact/timer.js
ig.baked=true;ig.module('impact.timer').defines(function(){"use strict";ig.Timer=ig.Class.extend({target:0,base:0,last:0,pausedAt:0,init:function(seconds){this.base=ig.Timer.time;this.last=ig.Timer.time;this.target=seconds||0;},set:function(seconds){this.target=seconds||0;this.base=ig.Timer.time;this.pausedAt=0;},reset:function(){this.base=ig.Timer.time;this.pausedAt=0;},tick:function(){var delta=ig.Timer.time-this.last;this.last=ig.Timer.time;return(this.pausedAt?0:delta);},delta:function(){return(this.pausedAt||ig.Timer.time)-this.base-this.target;},pause:function(){if(!this.pausedAt){this.pausedAt=ig.Timer.time;}},unpause:function(){if(this.pausedAt){this.base+=ig.Timer.time-this.pausedAt;this.pausedAt=0;}}});ig.Timer._last=0;ig.Timer.time=Number.MIN_VALUE;ig.Timer.timeScale=1;ig.Timer.maxStep=0.05;ig.Timer.step=function(){var current=Date.now();var delta=(current-ig.Timer._last)/1000;ig.Timer.time+=Math.min(delta,ig.Timer.maxStep)*ig.Timer.timeScale;ig.Timer._last=current;};});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/impact/system.js
ig.baked=true;ig.module('impact.system').requires('impact.timer','impact.image').defines(function(){"use strict";ig.System=ig.Class.extend({fps:30,width:320,height:240,realWidth:320,realHeight:240,scale:1,tick:0,animationId:0,newGameClass:null,running:false,delegate:null,clock:null,canvas:null,context:null,init:function(canvasId,fps,width,height,scale){this.fps=fps;this.clock=new ig.Timer();this.canvas=ig.$(canvasId);this.resize(width,height,scale);this.context=this.canvas.getContext('2d');this.getDrawPos=ig.System.drawMode;if(this.scale!=1){ig.System.scaleMode=ig.System.SCALE.CRISP;}
ig.System.scaleMode(this.canvas,this.context);},resize:function(width,height,scale){this.width=width;this.height=height;this.scale=scale||this.scale;this.realWidth=this.width*this.scale;this.realHeight=this.height*this.scale;this.canvas.width=this.realWidth;this.canvas.height=this.realHeight;},setGame:function(gameClass){if(this.running){this.newGameClass=gameClass;}
else{this.setGameNow(gameClass);}},setGameNow:function(gameClass){ig.game=new(gameClass)();ig.system.setDelegate(ig.game);},setDelegate:function(object){if(typeof(object.run)=='function'){this.delegate=object;this.startRunLoop();}else{throw('System.setDelegate: No run() function in object');}},stopRunLoop:function(){ig.clearAnimation(this.animationId);this.running=false;},startRunLoop:function(){this.stopRunLoop();this.animationId=ig.setAnimation(this.run.bind(this),this.canvas);this.running=true;},clear:function(color){this.context.fillStyle=color;this.context.fillRect(0,0,this.realWidth,this.realHeight);},run:function(){ig.Timer.step();this.tick=this.clock.tick();this.delegate.run();ig.input.clearPressed();if(this.newGameClass){this.setGameNow(this.newGameClass);this.newGameClass=null;}},getDrawPos:null});ig.System.DRAW={AUTHENTIC:function(p){return Math.round(p)*this.scale;},SMOOTH:function(p){return Math.round(p*this.scale);},SUBPIXEL:function(p){return p*this.scale;}};ig.System.drawMode=ig.System.DRAW.SMOOTH;ig.System.SCALE={CRISP:function(canvas,context){ig.setVendorAttribute(context,'imageSmoothingEnabled',false);canvas.style.imageRendering='-moz-crisp-edges';canvas.style.imageRendering='-o-crisp-edges';canvas.style.imageRendering='-webkit-optimize-contrast';canvas.style.imageRendering='crisp-edges';canvas.style.msInterpolationMode='nearest-neighbor';},SMOOTH:function(canvas,context){ig.setVendorAttribute(context,'imageSmoothingEnabled',true);canvas.style.imageRendering='';canvas.style.msInterpolationMode='';}};ig.System.scaleMode=ig.System.SCALE.SMOOTH;});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/impact/input.js
ig.baked=true;ig.module('impact.input').defines(function(){"use strict";ig.KEY={'MOUSE1':-1,'MOUSE2':-3,'MWHEEL_UP':-4,'MWHEEL_DOWN':-5,'BACKSPACE':8,'TAB':9,'ENTER':13,'PAUSE':19,'CAPS':20,'ESC':27,'SPACE':32,'PAGE_UP':33,'PAGE_DOWN':34,'END':35,'HOME':36,'LEFT_ARROW':37,'UP_ARROW':38,'RIGHT_ARROW':39,'DOWN_ARROW':40,'INSERT':45,'DELETE':46,'_0':48,'_1':49,'_2':50,'_3':51,'_4':52,'_5':53,'_6':54,'_7':55,'_8':56,'_9':57,'A':65,'B':66,'C':67,'D':68,'E':69,'F':70,'G':71,'H':72,'I':73,'J':74,'K':75,'L':76,'M':77,'N':78,'O':79,'P':80,'Q':81,'R':82,'S':83,'T':84,'U':85,'V':86,'W':87,'X':88,'Y':89,'Z':90,'NUMPAD_0':96,'NUMPAD_1':97,'NUMPAD_2':98,'NUMPAD_3':99,'NUMPAD_4':100,'NUMPAD_5':101,'NUMPAD_6':102,'NUMPAD_7':103,'NUMPAD_8':104,'NUMPAD_9':105,'MULTIPLY':106,'ADD':107,'SUBSTRACT':109,'DECIMAL':110,'DIVIDE':111,'F1':112,'F2':113,'F3':114,'F4':115,'F5':116,'F6':117,'F7':118,'F8':119,'F9':120,'F10':121,'F11':122,'F12':123,'SHIFT':16,'CTRL':17,'ALT':18,'PLUS':187,'COMMA':188,'MINUS':189,'PERIOD':190};ig.Input=ig.Class.extend({bindings:{},actions:{},presses:{},locks:{},delayedKeyup:{},isUsingMouse:false,isUsingKeyboard:false,isUsingAccelerometer:false,mouse:{x:0,y:0},accel:{x:0,y:0,z:0},initMouse:function(){if(this.isUsingMouse){return;}
this.isUsingMouse=true;var mouseWheelBound=this.mousewheel.bind(this);ig.system.canvas.addEventListener('mousewheel',mouseWheelBound,false);ig.system.canvas.addEventListener('DOMMouseScroll',mouseWheelBound,false);ig.system.canvas.addEventListener('contextmenu',this.contextmenu.bind(this),false);ig.system.canvas.addEventListener('mousedown',this.keydown.bind(this),false);ig.system.canvas.addEventListener('mouseup',this.keyup.bind(this),false);ig.system.canvas.addEventListener('mousemove',this.mousemove.bind(this),false);if(ig.ua.touchDevice){ig.system.canvas.addEventListener('touchstart',this.keydown.bind(this),false);ig.system.canvas.addEventListener('touchend',this.keyup.bind(this),false);ig.system.canvas.addEventListener('touchmove',this.mousemove.bind(this),false);ig.system.canvas.addEventListener('MSPointerDown',this.keydown.bind(this),false);ig.system.canvas.addEventListener('MSPointerUp',this.keyup.bind(this),false);ig.system.canvas.addEventListener('MSPointerMove',this.mousemove.bind(this),false);ig.system.canvas.style.msTouchAction='none';}},initKeyboard:function(){if(this.isUsingKeyboard){return;}
this.isUsingKeyboard=true;window.addEventListener('keydown',this.keydown.bind(this),false);window.addEventListener('keyup',this.keyup.bind(this),false);},initAccelerometer:function(){if(this.isUsingAccelerometer){return;}
this.isUsingAccelerometer=true;window.addEventListener('devicemotion',this.devicemotion.bind(this),false);},mousewheel:function(event){var delta=event.wheelDelta?event.wheelDelta:(event.detail*-1);var code=delta>0?ig.KEY.MWHEEL_UP:ig.KEY.MWHEEL_DOWN;var action=this.bindings[code];if(action){this.actions[action]=true;this.presses[action]=true;this.delayedKeyup[action]=true;event.stopPropagation();event.preventDefault();}},mousemove:function(event){var internalWidth=parseInt(ig.system.canvas.offsetWidth)||ig.system.realWidth;var scale=ig.system.scale*(internalWidth/ig.system.realWidth);var pos={left:0,top:0};if(ig.system.canvas.getBoundingClientRect){pos=ig.system.canvas.getBoundingClientRect();}
var ev=event.touches?event.touches[0]:event;this.mouse.x=(ev.clientX-pos.left)/scale;this.mouse.y=(ev.clientY-pos.top)/scale;},contextmenu:function(event){if(this.bindings[ig.KEY.MOUSE2]){event.stopPropagation();event.preventDefault();}},keydown:function(event){var tag=event.target.tagName;if(tag=='INPUT'||tag=='TEXTAREA'){return;}
var code=event.type=='keydown'?event.keyCode:(event.button==2?ig.KEY.MOUSE2:ig.KEY.MOUSE1);if(event.type=='touchstart'||event.type=='mousedown'){this.mousemove(event);}
var action=this.bindings[code];if(action){this.actions[action]=true;if(!this.locks[action]){this.presses[action]=true;this.locks[action]=true;}
event.stopPropagation();event.preventDefault();}},keyup:function(event){var tag=event.target.tagName;if(tag=='INPUT'||tag=='TEXTAREA'){return;}
var code=event.type=='keyup'?event.keyCode:(event.button==2?ig.KEY.MOUSE2:ig.KEY.MOUSE1);var action=this.bindings[code];if(action){this.delayedKeyup[action]=true;event.stopPropagation();event.preventDefault();}},devicemotion:function(event){this.accel=event.accelerationIncludingGravity;},bind:function(key,action){if(key<0){this.initMouse();}
else if(key>0){this.initKeyboard();}
this.bindings[key]=action;},bindTouch:function(selector,action){var element=ig.$(selector);var that=this;element.addEventListener('touchstart',function(ev){that.touchStart(ev,action);},false);element.addEventListener('touchend',function(ev){that.touchEnd(ev,action);},false);element.addEventListener('MSPointerDown',function(ev){that.touchStart(ev,action);},false);element.addEventListener('MSPointerUp',function(ev){that.touchEnd(ev,action);},false);},unbind:function(key){var action=this.bindings[key];this.delayedKeyup[action]=true;this.bindings[key]=null;},unbindAll:function(){this.bindings={};this.actions={};this.presses={};this.locks={};this.delayedKeyup={};},state:function(action){return this.actions[action];},pressed:function(action){return this.presses[action];},released:function(action){return!!this.delayedKeyup[action];},clearPressed:function(){for(var action in this.delayedKeyup){this.actions[action]=false;this.locks[action]=false;}
this.delayedKeyup={};this.presses={};},touchStart:function(event,action){this.actions[action]=true;this.presses[action]=true;event.stopPropagation();event.preventDefault();return false;},touchEnd:function(event,action){this.delayedKeyup[action]=true;event.stopPropagation();event.preventDefault();return false;}});});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/impact/impact.js
ig.baked=true;ig.module('impact.impact').requires('dom.ready','impact.loader','impact.system','impact.input','impact.sound').defines(function(){"use strict";ig.main=function(canvasId,gameClass,fps,width,height,scale,loaderClass){ig.system=new ig.System(canvasId,fps,width,height,scale||1);ig.input=new ig.Input();ig.soundManager=new ig.SoundManager();ig.music=new ig.Music();ig.ready=true;var loader=new(loaderClass||ig.Loader)(gameClass,ig.resources);loader.load();};});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/impact/animation.js
ig.baked=true;ig.module('impact.animation').requires('impact.timer','impact.image').defines(function(){"use strict";ig.AnimationSheet=ig.Class.extend({width:8,height:8,image:null,init:function(path,width,height){this.width=width;this.height=height;this.image=new ig.Image(path);}});ig.Animation=ig.Class.extend({sheet:null,timer:null,sequence:[],flip:{x:false,y:false},pivot:{x:0,y:0},frame:0,tile:0,loopCount:0,alpha:1,angle:0,init:function(sheet,frameTime,sequence,stop){this.sheet=sheet;this.pivot={x:sheet.width/2,y:sheet.height/2};this.timer=new ig.Timer();this.frameTime=frameTime;this.sequence=sequence;this.stop=!!stop;this.tile=this.sequence[0];},rewind:function(){this.timer.set();this.loopCount=0;this.frame=0;this.tile=this.sequence[0];return this;},gotoFrame:function(f){this.timer.set(this.frameTime*-f-0.0001);this.update();},gotoRandomFrame:function(){this.gotoFrame(Math.floor(Math.random()*this.sequence.length))},update:function(){var frameTotal=Math.floor(this.timer.delta()/this.frameTime);this.loopCount=Math.floor(frameTotal/this.sequence.length);if(this.stop&&this.loopCount>0){this.frame=this.sequence.length-1;}
else{this.frame=frameTotal%this.sequence.length;}
this.tile=this.sequence[this.frame];},draw:function(targetX,targetY){var bbsize=Math.max(this.sheet.width,this.sheet.height);if(targetX>ig.system.width||targetY>ig.system.height||targetX+bbsize<0||targetY+bbsize<0){return;}
if(this.alpha!=1){ig.system.context.globalAlpha=this.alpha;}
if(this.angle==0){this.sheet.image.drawTile(targetX,targetY,this.tile,this.sheet.width,this.sheet.height,this.flip.x,this.flip.y);}
else{ig.system.context.save();ig.system.context.translate(ig.system.getDrawPos(targetX+this.pivot.x),ig.system.getDrawPos(targetY+this.pivot.y));ig.system.context.rotate(this.angle);this.sheet.image.drawTile(-this.pivot.x,-this.pivot.y,this.tile,this.sheet.width,this.sheet.height,this.flip.x,this.flip.y);ig.system.context.restore();}
if(this.alpha!=1){ig.system.context.globalAlpha=1;}}});});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/impact/entity.js
ig.baked=true;ig.module('impact.entity').requires('impact.animation','impact.impact').defines(function(){"use strict";ig.Entity=ig.Class.extend({id:0,settings:{},size:{x:16,y:16},offset:{x:0,y:0},pos:{x:0,y:0},last:{x:0,y:0},vel:{x:0,y:0},accel:{x:0,y:0},friction:{x:0,y:0},maxVel:{x:100,y:100},zIndex:0,gravityFactor:1,standing:false,bounciness:0,minBounceVelocity:40,anims:{},animSheet:null,currentAnim:null,health:10,type:0,checkAgainst:0,collides:0,_killed:false,slopeStanding:{min:(44).toRad(),max:(136).toRad()},init:function(x,y,settings){this.id=++ig.Entity._lastId;this.pos.x=this.last.x=x;this.pos.y=this.last.y=y;ig.merge(this,settings);},reset:function(x,y,settings){var proto=this.constructor.prototype;this.pos.x=x;this.pos.y=y;this.last.x=x;this.last.y=y;this.vel.x=proto.vel.x;this.vel.y=proto.vel.y;this.accel.x=proto.accel.x;this.accel.y=proto.accel.y;this.health=proto.health;this._killed=proto._killed;this.standing=proto.standing;this.type=proto.type;this.checkAgainst=proto.checkAgainst;this.collides=proto.collides;ig.merge(this,settings);},addAnim:function(name,frameTime,sequence,stop){if(!this.animSheet){throw('No animSheet to add the animation '+name+' to.');}
var a=new ig.Animation(this.animSheet,frameTime,sequence,stop);this.anims[name]=a;if(!this.currentAnim){this.currentAnim=a;}
return a;},update:function(){this.last.x=this.pos.x;this.last.y=this.pos.y;this.vel.y+=ig.game.gravity*ig.system.tick*this.gravityFactor;this.vel.x=this.getNewVelocity(this.vel.x,this.accel.x,this.friction.x,this.maxVel.x);this.vel.y=this.getNewVelocity(this.vel.y,this.accel.y,this.friction.y,this.maxVel.y);var mx=this.vel.x*ig.system.tick;var my=this.vel.y*ig.system.tick;var res=ig.game.collisionMap.trace(this.pos.x,this.pos.y,mx,my,this.size.x,this.size.y);this.handleMovementTrace(res);if(this.currentAnim){this.currentAnim.update();}},getNewVelocity:function(vel,accel,friction,max){if(accel){return(vel+accel*ig.system.tick).limit(-max,max);}
else if(friction){var delta=friction*ig.system.tick;if(vel-delta>0){return vel-delta;}
else if(vel+delta<0){return vel+delta;}
else{return 0;}}
return vel.limit(-max,max);},handleMovementTrace:function(res){this.standing=false;if(res.collision.y){if(this.bounciness>0&&Math.abs(this.vel.y)>this.minBounceVelocity){this.vel.y*=-this.bounciness;}
else{if(this.vel.y>0){this.standing=true;}
this.vel.y=0;}}
if(res.collision.x){if(this.bounciness>0&&Math.abs(this.vel.x)>this.minBounceVelocity){this.vel.x*=-this.bounciness;}
else{this.vel.x=0;}}
if(res.collision.slope){var s=res.collision.slope;if(this.bounciness>0){var proj=this.vel.x*s.nx+this.vel.y*s.ny;this.vel.x=(this.vel.x-s.nx*proj*2)*this.bounciness;this.vel.y=(this.vel.y-s.ny*proj*2)*this.bounciness;}
else{var lengthSquared=s.x*s.x+s.y*s.y;var dot=(this.vel.x*s.x+this.vel.y*s.y)/lengthSquared;this.vel.x=s.x*dot;this.vel.y=s.y*dot;var angle=Math.atan2(s.x,s.y);if(angle>this.slopeStanding.min&&angle<this.slopeStanding.max){this.standing=true;}}}
this.pos=res.pos;},draw:function(){if(this.currentAnim){this.currentAnim.draw(this.pos.x-this.offset.x-ig.game._rscreen.x,this.pos.y-this.offset.y-ig.game._rscreen.y);}},kill:function(){ig.game.removeEntity(this);},receiveDamage:function(amount,from){this.health-=amount;if(this.health<=0){this.kill();}},touches:function(other){return!(this.pos.x>=other.pos.x+other.size.x||this.pos.x+this.size.x<=other.pos.x||this.pos.y>=other.pos.y+other.size.y||this.pos.y+this.size.y<=other.pos.y);},distanceTo:function(other){var xd=(this.pos.x+this.size.x/2)-(other.pos.x+other.size.x/2);var yd=(this.pos.y+this.size.y/2)-(other.pos.y+other.size.y/2);return Math.sqrt(xd*xd+yd*yd);},angleTo:function(other){return Math.atan2((other.pos.y+other.size.y/2)-(this.pos.y+this.size.y/2),(other.pos.x+other.size.x/2)-(this.pos.x+this.size.x/2));},check:function(other){},collideWith:function(other,axis){},ready:function(){},erase:function(){}});ig.Entity._lastId=0;ig.Entity.COLLIDES={NEVER:0,LITE:1,PASSIVE:2,ACTIVE:4,FIXED:8};ig.Entity.TYPE={NONE:0,A:1,B:2,BOTH:3};ig.Entity.checkPair=function(a,b){if(a.checkAgainst&b.type){a.check(b);}
if(b.checkAgainst&a.type){b.check(a);}
if(a.collides&&b.collides&&a.collides+b.collides>ig.Entity.COLLIDES.ACTIVE){ig.Entity.solveCollision(a,b);}};ig.Entity.solveCollision=function(a,b){var weak=null;if(a.collides==ig.Entity.COLLIDES.LITE||b.collides==ig.Entity.COLLIDES.FIXED){weak=a;}
else if(b.collides==ig.Entity.COLLIDES.LITE||a.collides==ig.Entity.COLLIDES.FIXED){weak=b;}
if(a.last.x+a.size.x>b.last.x&&a.last.x<b.last.x+b.size.x){if(a.last.y<b.last.y){ig.Entity.seperateOnYAxis(a,b,weak);}
else{ig.Entity.seperateOnYAxis(b,a,weak);}
a.collideWith(b,'y');b.collideWith(a,'y');}
else if(a.last.y+a.size.y>b.last.y&&a.last.y<b.last.y+b.size.y){if(a.last.x<b.last.x){ig.Entity.seperateOnXAxis(a,b,weak);}
else{ig.Entity.seperateOnXAxis(b,a,weak);}
a.collideWith(b,'x');b.collideWith(a,'x');}};ig.Entity.seperateOnXAxis=function(left,right,weak){var nudge=(left.pos.x+left.size.x-right.pos.x);if(weak){var strong=left===weak?right:left;weak.vel.x=-weak.vel.x*weak.bounciness+strong.vel.x;var resWeak=ig.game.collisionMap.trace(weak.pos.x,weak.pos.y,weak==left?-nudge:nudge,0,weak.size.x,weak.size.y);weak.pos.x=resWeak.pos.x;}
else{var v2=(left.vel.x-right.vel.x)/2;left.vel.x=-v2;right.vel.x=v2;var resLeft=ig.game.collisionMap.trace(left.pos.x,left.pos.y,-nudge/2,0,left.size.x,left.size.y);left.pos.x=Math.floor(resLeft.pos.x);var resRight=ig.game.collisionMap.trace(right.pos.x,right.pos.y,nudge/2,0,right.size.x,right.size.y);right.pos.x=Math.ceil(resRight.pos.x);}};ig.Entity.seperateOnYAxis=function(top,bottom,weak){var nudge=(top.pos.y+top.size.y-bottom.pos.y);if(weak){var strong=top===weak?bottom:top;weak.vel.y=-weak.vel.y*weak.bounciness+strong.vel.y;var nudgeX=0;if(weak==top&&Math.abs(weak.vel.y-strong.vel.y)<weak.minBounceVelocity){weak.standing=true;nudgeX=strong.vel.x*ig.system.tick;}
var resWeak=ig.game.collisionMap.trace(weak.pos.x,weak.pos.y,nudgeX,weak==top?-nudge:nudge,weak.size.x,weak.size.y);weak.pos.y=resWeak.pos.y;weak.pos.x=resWeak.pos.x;}
else if(ig.game.gravity&&(bottom.standing||top.vel.y>0)){var resTop=ig.game.collisionMap.trace(top.pos.x,top.pos.y,0,-(top.pos.y+top.size.y-bottom.pos.y),top.size.x,top.size.y);top.pos.y=resTop.pos.y;if(top.bounciness>0&&top.vel.y>top.minBounceVelocity){top.vel.y*=-top.bounciness;}
else{top.standing=true;top.vel.y=0;}}
else{var v2=(top.vel.y-bottom.vel.y)/2;top.vel.y=-v2;bottom.vel.y=v2;var nudgeX=bottom.vel.x*ig.system.tick;var resTop=ig.game.collisionMap.trace(top.pos.x,top.pos.y,nudgeX,-nudge/2,top.size.x,top.size.y);top.pos.y=resTop.pos.y;var resBottom=ig.game.collisionMap.trace(bottom.pos.x,bottom.pos.y,0,nudge/2,bottom.size.x,bottom.size.y);bottom.pos.y=resBottom.pos.y;}};});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/impact/map.js
ig.baked=true;ig.module('impact.map').defines(function(){"use strict";ig.Map=ig.Class.extend({tilesize:8,width:1,height:1,data:[[]],name:null,init:function(tilesize,data){this.tilesize=tilesize;this.data=data;this.height=data.length;this.width=data[0].length;this.pxWidth=this.width*this.tilesize;this.pxHeight=this.height*this.tilesize;},getTile:function(x,y){var tx=Math.floor(x/this.tilesize);var ty=Math.floor(y/this.tilesize);if((tx>=0&&tx<this.width)&&(ty>=0&&ty<this.height)){return this.data[ty][tx];}
else{return 0;}},setTile:function(x,y,tile){var tx=Math.floor(x/this.tilesize);var ty=Math.floor(y/this.tilesize);if((tx>=0&&tx<this.width)&&(ty>=0&&ty<this.height)){this.data[ty][tx]=tile;}}});});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/impact/collision-map.js
ig.baked=true;ig.module('impact.collision-map').requires('impact.map').defines(function(){"use strict";ig.CollisionMap=ig.Map.extend({lastSlope:1,tiledef:null,init:function(tilesize,data,tiledef){this.parent(tilesize,data);this.tiledef=tiledef||ig.CollisionMap.defaultTileDef;for(var t in this.tiledef){if(t|0>this.lastSlope){this.lastSlope=t|0;}}},trace:function(x,y,vx,vy,objectWidth,objectHeight){var res={collision:{x:false,y:false,slope:false},pos:{x:x,y:y},tile:{x:0,y:0}};var steps=Math.ceil(Math.max(Math.abs(vx),Math.abs(vy))/this.tilesize);if(steps>1){var sx=vx/steps;var sy=vy/steps;for(var i=0;i<steps&&(sx||sy);i++){this._traceStep(res,x,y,sx,sy,objectWidth,objectHeight,vx,vy,i);x=res.pos.x;y=res.pos.y;if(res.collision.x){sx=0;vx=0;}
if(res.collision.y){sy=0;vy=0;}
if(res.collision.slope){break;}}}
else{this._traceStep(res,x,y,vx,vy,objectWidth,objectHeight,vx,vy,0);}
return res;},_traceStep:function(res,x,y,vx,vy,width,height,rvx,rvy,step){res.pos.x+=vx;res.pos.y+=vy;var t=0;if(vx){var pxOffsetX=(vx>0?width:0);var tileOffsetX=(vx<0?this.tilesize:0);var firstTileY=Math.max(Math.floor(y/this.tilesize),0);var lastTileY=Math.min(Math.ceil((y+height)/this.tilesize),this.height);var tileX=Math.floor((res.pos.x+pxOffsetX)/this.tilesize);var prevTileX=Math.floor((x+pxOffsetX)/this.tilesize);if(step>0||tileX==prevTileX||prevTileX<0||prevTileX>=this.width){prevTileX=-1;}
if(tileX>=0&&tileX<this.width){for(var tileY=firstTileY;tileY<lastTileY;tileY++){if(prevTileX!=-1){t=this.data[tileY][prevTileX];if(t>1&&t<=this.lastSlope&&this._checkTileDef(res,t,x,y,rvx,rvy,width,height,prevTileX,tileY)){break;}}
t=this.data[tileY][tileX];if(t==1||t>this.lastSlope||(t>1&&this._checkTileDef(res,t,x,y,rvx,rvy,width,height,tileX,tileY))){if(t>1&&t<=this.lastSlope&&res.collision.slope){break;}
res.collision.x=true;res.tile.x=t;x=res.pos.x=tileX*this.tilesize-pxOffsetX+tileOffsetX;rvx=0;break;}}}}
if(vy){var pxOffsetY=(vy>0?height:0);var tileOffsetY=(vy<0?this.tilesize:0);var firstTileX=Math.max(Math.floor(res.pos.x/this.tilesize),0);var lastTileX=Math.min(Math.ceil((res.pos.x+width)/this.tilesize),this.width);var tileY=Math.floor((res.pos.y+pxOffsetY)/this.tilesize);var prevTileY=Math.floor((y+pxOffsetY)/this.tilesize);if(step>0||tileY==prevTileY||prevTileY<0||prevTileY>=this.height){prevTileY=-1;}
if(tileY>=0&&tileY<this.height){for(var tileX=firstTileX;tileX<lastTileX;tileX++){if(prevTileY!=-1){t=this.data[prevTileY][tileX];if(t>1&&t<=this.lastSlope&&this._checkTileDef(res,t,x,y,rvx,rvy,width,height,tileX,prevTileY)){break;}}
t=this.data[tileY][tileX];if(t==1||t>this.lastSlope||(t>1&&this._checkTileDef(res,t,x,y,rvx,rvy,width,height,tileX,tileY))){if(t>1&&t<=this.lastSlope&&res.collision.slope){break;}
res.collision.y=true;res.tile.y=t;res.pos.y=tileY*this.tilesize-pxOffsetY+tileOffsetY;break;}}}}},_checkTileDef:function(res,t,x,y,vx,vy,width,height,tileX,tileY){var def=this.tiledef[t];if(!def){return false;}
var lx=(tileX+def[0])*this.tilesize,ly=(tileY+def[1])*this.tilesize,lvx=(def[2]-def[0])*this.tilesize,lvy=(def[3]-def[1])*this.tilesize,solid=def[4];var tx=x+vx+(lvy<0?width:0)-lx,ty=y+vy+(lvx>0?height:0)-ly;if(lvx*ty-lvy*tx>0){if(vx*-lvy+vy*lvx<0){return solid;}
var length=Math.sqrt(lvx*lvx+lvy*lvy);var nx=lvy/length,ny=-lvx/length;var proj=tx*nx+ty*ny;var px=nx*proj,py=ny*proj;if(px*px+py*py>=vx*vx+vy*vy){return solid||(lvx*(ty-vy)-lvy*(tx-vx)<0.5);}
res.pos.x=x+vx-px;res.pos.y=y+vy-py;res.collision.slope={x:lvx,y:lvy,nx:nx,ny:ny};return true;}
return false;}});var H=1/2,N=1/3,M=2/3,SOLID=true,NON_SOLID=false;ig.CollisionMap.defaultTileDef={5:[0,1,1,M,SOLID],6:[0,M,1,N,SOLID],7:[0,N,1,0,SOLID],3:[0,1,1,H,SOLID],4:[0,H,1,0,SOLID],2:[0,1,1,0,SOLID],10:[H,1,1,0,SOLID],21:[0,1,H,0,SOLID],32:[M,1,1,0,SOLID],43:[N,1,M,0,SOLID],54:[0,1,N,0,SOLID],27:[0,0,1,N,SOLID],28:[0,N,1,M,SOLID],29:[0,M,1,1,SOLID],25:[0,0,1,H,SOLID],26:[0,H,1,1,SOLID],24:[0,0,1,1,SOLID],11:[0,0,H,1,SOLID],22:[H,0,1,1,SOLID],33:[0,0,N,1,SOLID],44:[N,0,M,1,SOLID],55:[M,0,1,1,SOLID],16:[1,N,0,0,SOLID],17:[1,M,0,N,SOLID],18:[1,1,0,M,SOLID],14:[1,H,0,0,SOLID],15:[1,1,0,H,SOLID],13:[1,1,0,0,SOLID],8:[H,1,0,0,SOLID],19:[1,1,H,0,SOLID],30:[N,1,0,0,SOLID],41:[M,1,N,0,SOLID],52:[1,1,M,0,SOLID],38:[1,M,0,1,SOLID],39:[1,N,0,M,SOLID],40:[1,0,0,N,SOLID],36:[1,H,0,1,SOLID],37:[1,0,0,H,SOLID],35:[1,0,0,1,SOLID],9:[1,0,H,1,SOLID],20:[H,0,0,1,SOLID],31:[1,0,M,1,SOLID],42:[M,0,N,1,SOLID],53:[N,0,0,1,SOLID],12:[0,0,1,0,NON_SOLID],23:[1,1,0,1,NON_SOLID],34:[1,0,1,1,NON_SOLID],45:[0,1,0,0,NON_SOLID]};ig.CollisionMap.staticNoCollision={trace:function(x,y,vx,vy){return{collision:{x:false,y:false,slope:false},pos:{x:x+vx,y:y+vy},tile:{x:0,y:0}};}};});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/impact/background-map.js
ig.baked=true;ig.module('impact.background-map').requires('impact.map','impact.image').defines(function(){"use strict";ig.BackgroundMap=ig.Map.extend({tiles:null,scroll:{x:0,y:0},distance:1,repeat:false,tilesetName:'',foreground:false,enabled:true,preRender:false,preRenderedChunks:null,chunkSize:512,debugChunks:false,anims:{},init:function(tilesize,data,tileset){this.parent(tilesize,data);this.setTileset(tileset);},setTileset:function(tileset){this.tilesetName=tileset instanceof ig.Image?tileset.path:tileset;this.tiles=new ig.Image(this.tilesetName);this.preRenderedChunks=null;},setScreenPos:function(x,y){this.scroll.x=x/this.distance;this.scroll.y=y/this.distance;},preRenderMapToChunks:function(){var totalWidth=this.width*this.tilesize*ig.system.scale,totalHeight=this.height*this.tilesize*ig.system.scale;this.chunkSize=Math.min(Math.max(totalWidth,totalHeight),this.chunkSize);var chunkCols=Math.ceil(totalWidth/this.chunkSize),chunkRows=Math.ceil(totalHeight/this.chunkSize);this.preRenderedChunks=[];for(var y=0;y<chunkRows;y++){this.preRenderedChunks[y]=[];for(var x=0;x<chunkCols;x++){var chunkWidth=(x==chunkCols-1)?totalWidth-x*this.chunkSize:this.chunkSize;var chunkHeight=(y==chunkRows-1)?totalHeight-y*this.chunkSize:this.chunkSize;this.preRenderedChunks[y][x]=this.preRenderChunk(x,y,chunkWidth,chunkHeight);}}},preRenderChunk:function(cx,cy,w,h){var tw=w/this.tilesize/ig.system.scale+1,th=h/this.tilesize/ig.system.scale+1;var nx=(cx*this.chunkSize/ig.system.scale)%this.tilesize,ny=(cy*this.chunkSize/ig.system.scale)%this.tilesize;var tx=Math.floor(cx*this.chunkSize/this.tilesize/ig.system.scale),ty=Math.floor(cy*this.chunkSize/this.tilesize/ig.system.scale);var chunk=ig.$new('canvas');chunk.width=w;chunk.height=h;chunk.retinaResolutionEnabled=false;var chunkContext=chunk.getContext('2d');ig.System.scaleMode(chunk,chunkContext);var screenContext=ig.system.context;ig.system.context=chunkContext;for(var x=0;x<tw;x++){for(var y=0;y<th;y++){if(x+tx<this.width&&y+ty<this.height){var tile=this.data[y+ty][x+tx];if(tile){this.tiles.drawTile(x*this.tilesize-nx,y*this.tilesize-ny,tile-1,this.tilesize);}}}}
ig.system.context=screenContext;return chunk;},draw:function(){if(!this.tiles.loaded||!this.enabled){return;}
if(this.preRender){this.drawPreRendered();}
else{this.drawTiled();}},drawPreRendered:function(){if(!this.preRenderedChunks){this.preRenderMapToChunks();}
var dx=ig.system.getDrawPos(this.scroll.x),dy=ig.system.getDrawPos(this.scroll.y);if(this.repeat){var w=this.width*this.tilesize*ig.system.scale;dx=(dx%w+w)%w;var h=this.height*this.tilesize*ig.system.scale;dy=(dy%h+h)%h;}
var minChunkX=Math.max(Math.floor(dx/this.chunkSize),0),minChunkY=Math.max(Math.floor(dy/this.chunkSize),0),maxChunkX=Math.ceil((dx+ig.system.realWidth)/this.chunkSize),maxChunkY=Math.ceil((dy+ig.system.realHeight)/this.chunkSize),maxRealChunkX=this.preRenderedChunks[0].length,maxRealChunkY=this.preRenderedChunks.length;if(!this.repeat){maxChunkX=Math.min(maxChunkX,maxRealChunkX);maxChunkY=Math.min(maxChunkY,maxRealChunkY);}
var nudgeY=0;for(var cy=minChunkY;cy<maxChunkY;cy++){var nudgeX=0;for(var cx=minChunkX;cx<maxChunkX;cx++){var chunk=this.preRenderedChunks[cy%maxRealChunkY][cx%maxRealChunkX];var x=-dx+cx*this.chunkSize-nudgeX;var y=-dy+cy*this.chunkSize-nudgeY;ig.system.context.drawImage(chunk,x,y);ig.Image.drawCount++;if(this.debugChunks){ig.system.context.strokeStyle='#f0f';ig.system.context.strokeRect(x,y,this.chunkSize,this.chunkSize);}
if(this.repeat&&chunk.width<this.chunkSize&&x+chunk.width<ig.system.realWidth){nudgeX+=this.chunkSize-chunk.width;maxChunkX++;}}
if(this.repeat&&chunk.height<this.chunkSize&&y+chunk.height<ig.system.realHeight){nudgeY+=this.chunkSize-chunk.height;maxChunkY++;}}},drawTiled:function(){var tile=0,anim=null,tileOffsetX=(this.scroll.x/this.tilesize).toInt(),tileOffsetY=(this.scroll.y/this.tilesize).toInt(),pxOffsetX=this.scroll.x%this.tilesize,pxOffsetY=this.scroll.y%this.tilesize,pxMinX=-pxOffsetX-this.tilesize,pxMinY=-pxOffsetY-this.tilesize,pxMaxX=ig.system.width+this.tilesize-pxOffsetX,pxMaxY=ig.system.height+this.tilesize-pxOffsetY;for(var mapY=-1,pxY=pxMinY;pxY<pxMaxY;mapY++,pxY+=this.tilesize){var tileY=mapY+tileOffsetY;if(tileY>=this.height||tileY<0){if(!this.repeat){continue;}
tileY=(tileY%this.height+this.height)%this.height;}
for(var mapX=-1,pxX=pxMinX;pxX<pxMaxX;mapX++,pxX+=this.tilesize){var tileX=mapX+tileOffsetX;if(tileX>=this.width||tileX<0){if(!this.repeat){continue;}
tileX=(tileX%this.width+this.width)%this.width;}
if((tile=this.data[tileY][tileX])){if((anim=this.anims[tile-1])){anim.draw(pxX,pxY);}
else{this.tiles.drawTile(pxX,pxY,tile-1,this.tilesize);}}}}}});});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/impact/game.js
ig.baked=true;ig.module('impact.game').requires('impact.impact','impact.entity','impact.collision-map','impact.background-map').defines(function(){"use strict";ig.Game=ig.Class.extend({clearColor:'#000000',gravity:0,screen:{x:0,y:0},_rscreen:{x:0,y:0},entities:[],namedEntities:{},collisionMap:ig.CollisionMap.staticNoCollision,backgroundMaps:[],backgroundAnims:{},autoSort:false,sortBy:null,cellSize:64,_deferredKill:[],_levelToLoad:null,_doSortEntities:false,staticInstantiate:function(){this.sortBy=this.sortBy||ig.Game.SORT.Z_INDEX;ig.game=this;return null;},loadLevel:function(data){this.screen={x:0,y:0};this.entities=[];this.namedEntities={};for(var i=0;i<data.entities.length;i++){var ent=data.entities[i];this.spawnEntity(ent.type,ent.x,ent.y,ent.settings);}
this.sortEntities();this.collisionMap=ig.CollisionMap.staticNoCollision;this.backgroundMaps=[];for(var i=0;i<data.layer.length;i++){var ld=data.layer[i];if(ld.name=='collision'){this.collisionMap=new ig.CollisionMap(ld.tilesize,ld.data);}
else{var newMap=new ig.BackgroundMap(ld.tilesize,ld.data,ld.tilesetName);newMap.anims=this.backgroundAnims[ld.tilesetName]||{};newMap.repeat=ld.repeat;newMap.distance=ld.distance;newMap.foreground=!!ld.foreground;newMap.preRender=!!ld.preRender;newMap.name=ld.name;this.backgroundMaps.push(newMap);}}
for(var i=0;i<this.entities.length;i++){this.entities[i].ready();}},loadLevelDeferred:function(data){this._levelToLoad=data;},getMapByName:function(name){if(name=='collision'){return this.collisionMap;}
for(var i=0;i<this.backgroundMaps.length;i++){if(this.backgroundMaps[i].name==name){return this.backgroundMaps[i];}}
return null;},getEntityByName:function(name){return this.namedEntities[name];},getEntitiesByType:function(type){var entityClass=typeof(type)==='string'?ig.global[type]:type;var a=[];for(var i=0;i<this.entities.length;i++){var ent=this.entities[i];if(ent instanceof entityClass&&!ent._killed){a.push(ent);}}
return a;},spawnEntity:function(type,x,y,settings){var entityClass=typeof(type)==='string'?ig.global[type]:type;if(!entityClass){throw("Can't spawn entity of type "+type);}
var ent=new(entityClass)(x,y,settings||{});this.entities.push(ent);if(ent.name){this.namedEntities[ent.name]=ent;}
return ent;},sortEntities:function(){this.entities.sort(this.sortBy);},sortEntitiesDeferred:function(){this._doSortEntities=true;},removeEntity:function(ent){if(ent.name){delete this.namedEntities[ent.name];}
ent._killed=true;ent.type=ig.Entity.TYPE.NONE;ent.checkAgainst=ig.Entity.TYPE.NONE;ent.collides=ig.Entity.COLLIDES.NEVER;this._deferredKill.push(ent);},run:function(){this.update();this.draw();},update:function(){if(this._levelToLoad){this.loadLevel(this._levelToLoad);this._levelToLoad=null;}
this.updateEntities();this.checkEntities();for(var i=0;i<this._deferredKill.length;i++){this._deferredKill[i].erase();this.entities.erase(this._deferredKill[i]);}
this._deferredKill=[];if(this._doSortEntities||this.autoSort){this.sortEntities();this._doSortEntities=false;}
for(var tileset in this.backgroundAnims){var anims=this.backgroundAnims[tileset];for(var a in anims){anims[a].update();}}},updateEntities:function(){for(var i=0;i<this.entities.length;i++){var ent=this.entities[i];if(!ent._killed){ent.update();}}},draw:function(){if(this.clearColor){ig.system.clear(this.clearColor);}
this._rscreen.x=ig.system.getDrawPos(this.screen.x)/ig.system.scale;this._rscreen.y=ig.system.getDrawPos(this.screen.y)/ig.system.scale;var mapIndex;for(mapIndex=0;mapIndex<this.backgroundMaps.length;mapIndex++){var map=this.backgroundMaps[mapIndex];if(map.foreground){break;}
map.setScreenPos(this.screen.x,this.screen.y);map.draw();}
this.drawEntities();for(mapIndex;mapIndex<this.backgroundMaps.length;mapIndex++){var map=this.backgroundMaps[mapIndex];map.setScreenPos(this.screen.x,this.screen.y);map.draw();}},drawEntities:function(){for(var i=0;i<this.entities.length;i++){this.entities[i].draw();}},checkEntities:function(){var hash={};for(var e=0;e<this.entities.length;e++){var entity=this.entities[e];if(entity.type==ig.Entity.TYPE.NONE&&entity.checkAgainst==ig.Entity.TYPE.NONE&&entity.collides==ig.Entity.COLLIDES.NEVER){continue;}
var checked={},xmin=Math.floor(entity.pos.x/this.cellSize),ymin=Math.floor(entity.pos.y/this.cellSize),xmax=Math.floor((entity.pos.x+entity.size.x)/this.cellSize)+1,ymax=Math.floor((entity.pos.y+entity.size.y)/this.cellSize)+1;for(var x=xmin;x<xmax;x++){for(var y=ymin;y<ymax;y++){if(!hash[x]){hash[x]={};hash[x][y]=[entity];}
else if(!hash[x][y]){hash[x][y]=[entity];}
else{var cell=hash[x][y];for(var c=0;c<cell.length;c++){if(entity.touches(cell[c])&&!checked[cell[c].id]){checked[cell[c].id]=true;ig.Entity.checkPair(entity,cell[c]);}}
cell.push(entity);}}}}}});ig.Game.SORT={Z_INDEX:function(a,b){return a.zIndex-b.zIndex;},POS_X:function(a,b){return(a.pos.x+a.size.x)-(b.pos.x+b.size.x);},POS_Y:function(a,b){return(a.pos.y+a.size.y)-(b.pos.y+b.size.y);}};});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/plugins/midas/draw.js
ig.baked=true;ig.module('plugins.midas.draw').requires('impact.impact').defines(function(){Color=function(r,g,b,a){this.red=r;this.green=g;this.blue=b;this.alpha=a;var colorString="";this.toString=function(){if(colorString==""){colorString="rgba("+this.red+","+this.green+","+this.blue+","+this.alpha+")";}
return colorString;};};PluginDraw=function(){var strokeColor="#000000",lineWidth=1,fillColor=null,lineCap=null,strokeDirty=false,fillDirty=false,lineCapDirty=false;this.hexToRgb=function(hex){var shorthandRegex=/^#?([a-f\d])([a-f\d])([a-f\d])$/i;hex=hex.replace(shorthandRegex,function(m,r,g,b){return r+r+g+g+b+b;});var result=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(hex);if(result){var red=parseInt(result[1],16);var green=parseInt(result[2],16);var blue=parseInt(result[3],16);var color=new Color(red,green,blue,1);return color;}};this.setLineWidth=function(newLineWidth){lineWidth=newLineWidth;};this.setStroke=function(newStrokeColor){if(strokeColor!=newStrokeColor){strokeDirty=true;}
strokeColor=newStrokeColor;};this.setFill=function(newFillColor){if(fillColor!=newFillColor){fillDirty=true;}
fillColor=newFillColor;};this.setLineCap=function(newLineCap){if(lineCap!=newLineCap){lineCapDirty=true;}
lineCap=newLineCap;};this.getContext=function(){return ig.system.context;};this.rect=function(x,y,width,height){var context=this.getContext();var scale=ig.system.scale;var scaledOffsetRect={x:scale*x-scale*ig.game.screen.x,y:scale*y-scale*ig.game.screen.y,width:scale*width,height:scale*height};context.beginPath();context.rect(scaledOffsetRect.x,scaledOffsetRect.y,scaledOffsetRect.width,scaledOffsetRect.height);if(fillColor){if(fillDirty){context.fillStyle=fillColor;fillDirty=false;}
context.fill();}
if(strokeColor){if(strokeDirty){context.strokeStyle=strokeColor;strokeDirty=false;}
context.lineWidth=lineWidth;context.stroke();}
this.reset();};this.line=function(x1,y1,x2,y2){var context=this.getContext();var scale=ig.system.scale;var startingVector={x:scale*x1-scale*ig.game.screen.x,y:scale*y1-scale*ig.game.screen.y};var endingVector={x:scale*x2-scale*ig.game.screen.x,y:scale*y2-scale*ig.game.screen.y};context.beginPath();context.moveTo(startingVector.x,startingVector.y);context.lineTo(endingVector.x,endingVector.y);context.strokeStyle=strokeColor;context.lineWidth=lineWidth;if(lineCapDirty){context.lineCap=lineCap;lineCapDirty=false;}
context.stroke();};this.point=function(x,y){this.line(x,y,x+1,y+1);};this.reset=function(){var context=this.getContext();this.strokeColor="#000000";this.lineWidth=1;this.fillColor=null;context.strokeStyle=strokeColor;context.fillStyle=fillColor;context.lineWidth=lineWidth;};this.circle=function(centerX,centerY,radius){var context=this.getContext();var scale=ig.system.scale;if(fillColor){context.beginPath();context.arc(centerX+ig.game.screen.x,centerY+ig.game.screen.y,scale*radius,0,2*Math.PI,false);context.closePath();if(fillDirty){context.fillStyle=fillColor;fillDirty=false;}
context.fill();}
if(strokeColor){var strokeRadius=(radius-(lineWidth/2));context.beginPath();context.arc(centerX+ig.game.screen.x,centerY+ig.game.screen.y,scale*strokeRadius,0,2*Math.PI,false);context.closePath();if(strokeDirty){context.strokeStyle=strokeColor;strokeDirty=false;}
context.lineWidth=lineWidth;context.stroke();}};this.poly=function(points){var context=this.getContext();context.beginPath();context.moveTo(points[0][0],points[0][1]);for(var i=1;i<points.length;i++){context.lineTo(points[i][0],points[i][1]);}
context.closePath();if(fillColor){if(fillDirty){context.fillStyle=fillColor;fillDirty=false;}
context.fill();}
if(strokeColor){if(strokeDirty){context.strokeStyle=strokeColor;strokeDirty=false;}
context.lineWidth=lineWidth;context.stroke();}};};ig.draw=new PluginDraw();});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/launcher/ui/lifepip.js
ig.baked=true;ig.module('launcher.ui.lifepip').requires('impact.impact','plugins.midas.draw').defines(function(){LifePip=ig.Class.extend({activeColor:pmGameData.backgroundColor,disabledColor:pmGameData.backgroundHighlightColor,activeCircleColor:"white",disabledCircleColor:"rgba(255, 255, 255, 0.5)",drawActive:function(x,y){ig.draw.reset();ig.draw.setFill(this.activeColor);ig.draw.setStroke(null);ig.draw.circle(x,y,12);ig.draw.setFill(this.activeCircleColor);ig.draw.circle(x,y,9);ig.draw.setFill(this.activeColor);ig.draw.circle(x,y,7);},drawDisabled:function(x,y){ig.draw.reset();ig.draw.setFill(this.disabledColor);ig.draw.setStroke(null);ig.draw.circle(x,y,12);ig.draw.setFill(this.disabledCircleColor);ig.draw.circle(x,y,9);}});});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/plugins/midas/clocks.js
ig.baked=true;ig.module('plugins.midas.clocks').requires('impact.impact').defines(function(){TrueClock=ig.Class.extend({getMilliseconds:function(){var date=new Date();return date.getTime();}});TrueStopwatch=ig.Class.extend({clock:new TrueClock(),base:0,target:0,pauseTime:0,running:false,init:function(){var milliseconds=this.clock.getMilliseconds();this.base=milliseconds;this.target=milliseconds;this.pauseTime=milliseconds;},start:function(){if(!this.running){this.base=this.clock.getMilliseconds();this.running=true;}},get:function(){if(this.running){return this.clock.getMilliseconds()-this.base;}
return this.target-this.base;},pause:function(){if(this.running){var milliseconds=this.clock.getMilliseconds();this.pauseTime=milliseconds;this.target=milliseconds;this.running=false;}},unpause:function(){if(!this.running){var milliseconds=this.clock.getMilliseconds();this.base+=milliseconds-this.pauseTime;this.pauseTime=milliseconds;this.running=true;}},stop:function(){if(this.running){this.target=this.clock.getMilliseconds();this.running=false;}},reset:function(){this.base=this.clock.getMilliseconds();this.target=this.base;this.running=false;}});TrueTimer=ig.Class.extend({clock:new TrueClock(),base:0,target:0,running:false,timerCallback:function(){},init:function(){var milliseconds=this.clock.getMilliseconds();this.base=milliseconds;this.target=milliseconds;},start:function(milliseconds){if(!this.running){this.base=this.clock.getMilliseconds();this.target=this.base+milliseconds;this.running=true;}},get:function(){var remaining=this.target-this.clock.getMilliseconds();if(this.running){if(remaining<=0){this.running=false;remaining=0;this.timerCallback();}}else{remaining=this.target-this.base;}
return remaining;},stop:function(){if(this.running){this.base=this.clock.getMilliseconds();this.running=false;}},reset:function(){this.base=this.clock.getMilliseconds();this.target=this.base;},setTimerCallback:function(callback){this.timerCallback=callback;}});});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/launcher/ui/header.js
ig.baked=true;ig.module('launcher.ui.header').requires('impact.game','impact.timer','launcher.ui.lifepip','plugins.midas.draw','plugins.midas.clocks').defines(function(){HeaderUI=ig.Class.extend({size:{x:800,y:50},clearColor:pmGameData.complementColor,numberFont:new ig.Font(pmGameData.assetPath+'common/proxima-semibold-24-white.font.png'),labelFont:new ig.Font(pmGameData.assetPath+'common/proxima-extrabold-12-white.font.png'),timerImage:new ig.Image(pmGameData.assetPath+'common/gameclock.png'),activePips:0,disabledPips:0,timerStart:false,stopwatch:new TrueStopwatch(),timer:new TrueTimer(),stopwatchEnabled:false,timerEnabled:false,lifeEnabled:false,scoreEnabled:false,totalPips:0,trueLifePip:null,init:function(){this.trueLifePip=new LifePip();},update:function(){this.displayTime=this.formatForMilliseconds(this.stopwatch.get());},formatForMilliseconds:function(delta){var displayTime="0:00";var seconds=Math.floor(delta/1000);var milliseconds=Math.floor(delta-seconds*1000);if(seconds/60>=1){displayTime=this.formatForMinutes(seconds);}else{displayTime=this.formatForSeconds(seconds);}
displayTime+=":";if(milliseconds<100){displayTime+="0";}
displayTime+=Math.floor(milliseconds/10);return displayTime;},formatForSeconds:function(seconds){var displayTime="00";if(seconds<10){displayTime="0"+seconds;}else if(seconds>=10){displayTime=""+seconds;}
return displayTime;},formatForMinutes:function(seconds){var displayTime="0:00";if(seconds>=60){displayTime=Math.floor(seconds/60)+":";if(seconds%60<10){displayTime+="0";}
displayTime+=seconds%60;}else{displayTime="0:"+this.formatForSeconds(delta);}
return displayTime;},draw:function(){ig.draw.reset();ig.draw.setFill(this.clearColor);ig.draw.setStroke(null);ig.draw.rect(0,0,this.size.x,this.size.y);if(this.stopwatchEnabled||this.timerEnabled){this.timerImage.draw(10,10);this.numberFont.draw(this.displayTime,50,12,ig.Font.ALIGN.LEFT);}
if(this.lifeEnabled){var lastPipDrawn=620;for(var i=Math.min(this.totalPips-1,this.activePips-1);i>=0;i--){this.trueLifePip.drawActive(lastPipDrawn-i*30,25);}
lastPipDrawn-=this.activePips*30;for(var i=0;i<this.disabledPips;i++){this.trueLifePip.drawDisabled(lastPipDrawn-i*30,25);}}
if(this.scoreEnabled){this.numberFont.draw(""+this.prettyPrintScore(ig.global['score']),790,12,ig.Font.ALIGN.RIGHT);}},setPips:function(activated,deactivated){this.totalPips=activated+deactivated;this.activePips=activated;this.disabledPips=deactivated;},addActivePip:function(){this.activePips++;this.totalPips++;},addDisabledPip:function(){this.disabledPips++;this.totalPips++;},activateNextPip:function(){this.activePips++;this.disabledPips--;},deactivateNextPip:function(){this.activePips--;this.disabledPips++;},startStopwatch:function(){this.stopwatch.start();},pauseStopwatch:function(){this.stopwatch.pause();},unpauseStopwatch:function(){this.stopwatch.unpause();},clearStopwatch:function(){this.stopwatch.reset();},getClock:function(){return this.stopwatch.get();},enableStopwatch:function(){this.stopwatchEnabled=true;},enableLife:function(){this.lifeEnabled=true;},enableScore:function(){this.scoreEnabled=true;},prettyPrintScore:function(rawScore){var scoreString=Math.floor(rawScore).toLocaleString();return scoreString;}});});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/plugins/midas/button.js
ig.baked=true;ig.module('plugins.midas.button').requires('impact.entity').defines(function(){EntityButton=ig.Entity.extend({size:{x:80,y:40},animSheet:null,state:'idle',wasPreviouslyPressed:false,wasPreviouslyHovered:false,init:function(x,y,settings){this.parent(x,y,settings);this.addAnim('idle',1,[0]);this.addAnim('active',1,[1]);this.addAnim('hover',1,[2]);},update:function(){if(this.state!=='hidden'){var isClicked=ig.input.state('click');if(this.mouseWithinButton()){this.wasPreviouslyHovered=true;document.body.style.cursor="pointer";if(isClicked){this.setState('active');if(this.wasPreviouslyPressed){this.pressed();}else{this.onPress();}
this.wasPreviouslyPressed=true;}else{this.setState('hover');if(this.wasPreviouslyPressed){document.body.style.cursor="default";this.onRelease();}
this.wasPreviouslyPressed=false;}}else{if(this.wasPreviouslyHovered){document.body.style.cursor="default";this.setState('idle');this.wasPreviouslyPressed=false;this.wasPreviouslyHovered=false;}}}},draw:function(){if(this.state!=='hidden'){this.parent();}},setState:function(s){this.state=s;if(this.state!=='hidden'){this.currentAnim=this.anims[this.state];}},onPress:function(){},pressed:function(){},onRelease:function(){},mouseWithinButton:function(){return ig.input.mouse.x+ig.game.screen.x>this.pos.x&&ig.input.mouse.x+ig.game.screen.x<this.pos.x+this.size.x&&ig.input.mouse.y+ig.game.screen.y>this.pos.y&&ig.input.mouse.y+ig.game.screen.y<this.pos.y+this.size.y;}});});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/launcher/ui/credits.js
ig.baked=true;ig.module('launcher.ui.credits').requires('impact.game','impact.entity','plugins.midas.draw','plugins.midas.button').defines(function(){CreditsButton=EntityButton.extend({isDoingFade:false,fadeDirection:0.1,init:function(x,y,settings){this.parent(x,y,settings);this.anims.idle.alpha=0;},update:function(){if(this.mouseWithinButton()){if(!this.isDoingFade&&this.currentAnim.alpha!=1){this.anims.idle.alpha=0;this.anims.hover.alpha=0;this.fadeDirection=0.1;this.isDoingFade=true;}}else{if(!this.isDoingFade&&this.currentAnim.alpha!=0){this.anims.hover.alpha=0;this.anims.idle.alpha=1;this.fadeDirection=-0.1;this.isDoingFade=true;}}
if(this.isDoingFade){this.currentAnim.alpha+=this.fadeDirection;if(this.currentAnim.alpha>=1){this.currentAnim.alpha=1;this.isDoingFade=false;}
if(this.currentAnim.alpha<=0){this.currentAnim.alpha=0;this.isDoingFade=false;}}
this.parent();},draw:function(){this.parent();}});Credits=ig.Game.extend({clearColor:"#000000",font:new ig.Font('common/proxima-extrabold-30-white.font.png'),scrollPos:0,creditsText:"Credits\n\n\nProgramming and Game Design:\nJustin Gilman\n\n\nArt and UI Design:\nJason Calleiro\n\n\nServer API:\nScott Shervington",loopCredits:false,endCredits:true,buttonClick:new ig.Sound(pmGameData.assetPath+'common/button-click.*'),init:function(){ig.game.spawnEntity(EntityButton,650,450,{size:{x:128,y:128},animSheet:new ig.AnimationSheet('common/backbutton.png',128,128),onRelease:function(){ig.game.buttonClick.play();ig.system.setGame(MainMenu);}});if(this.font.heightForString(this.creditsText)>ig.system.height){this.loopCredits=true;}},update:function(){if(this.loopCredits){if(this.scrollPos+ig.system.height>-100-this.font.heightForString(this.creditsText)){this.scrollPos--;}else{if(this.endCredits){ig.system.setGame(MainMenu);}else{this.scrollPos=0;}}}else{if(this.scrollPos+ig.system.height>(ig.system.height-this.font.heightForString(this.creditsText))/2){this.scrollPos--;}}
this.parent();},draw:function(){this.parent();this.font.draw(this.creditsText,ig.system.width/2,this.scrollPos+ig.system.height,ig.Font.ALIGN.CENTER);}});});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/plugins/midas/browserinfo.js
ig.baked=true;ig.module('plugins.midas.browserinfo').requires('impact.impact').defines(function(){PluginBrowserInfo=function(){this.getName=function(){var name=navigator.appName;var userAgent=navigator.userAgent;var nameMatch=userAgent.match(/(opera|chrome|safari|firefox|msie)\/?\s*(\.?\d+(\.\d+)*)/i);if(nameMatch){name=nameMatch[1];}
return name;};this.getVersion=function(){var version=navigator.appVersion;var userAgent=navigator.userAgent;var versionMatch=userAgent.match(/version\/([\.\d]+)/i);var nameMatch=userAgent.match(/(opera|chrome|safari|firefox|msie)\/?\s*(\.?\d+(\.\d+)*)/i);if(nameMatch){version=nameMatch[2];if(versionMatch!=null){version=versionMatch[1];}}
return version;};this.getMajorVersion=function(){return this.getVersion().split('.')[0];};this.getMinorVersion=function(){return this.getVersion().split('.')[1];};this.shouldBlock=function(browserFilter){for(var i=0;i<browserFilter.length;i++){var browserRule=browserFilter[i];if(browserRule.name.toLowerCase()==this.getName().toLowerCase()&&this.getMajorVersion()<=browserRule.version){return true;}}
return false;};};ig.browserInfo=new PluginBrowserInfo();});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/plugins/midas/arrayutils.js
ig.baked=true;ig.module('plugins.midas.arrayutils').requires('impact.impact').defines(function(){PluginArrayUtils=function(){var populateDiffArray=function(array1,diffData){var match=false;for(var j=0;j<array1.length;j++){match=false;for(var i=0;i<diffData.length;i++){if(ig.arrayUtils.compare(array1[j],diffData[i].item)){diffData[i].count++;match=true;}}
if(!match){diffData.push({item:array1[j],count:1});}}
return diffData;};this.shuffle=function(obj){var rand;var index=0;var shuffled=[];this.each(obj,function(value){rand=Math.floor(Math.random()*index);shuffled[index]=shuffled[rand];index++;shuffled[rand]=value;});return shuffled;};this.each=function(obj,iterator,context){if(obj==null)return;for(var key in obj){if(this.has(obj,key)){if(iterator.call(context,obj[key],key,obj)==={})return;}}};this.has=function(obj,key){return obj.hasOwnProperty(key);};this.contains=function(needle,haystack){for(var i=0;i<haystack.length;i++){if(haystack[i]===needle){return true;}}
return false;};this.removeDuplicates=function(dirtyArray){var cleaned=[];var found=null;for(var j=0;j<dirtyArray.length;j++){var value=dirtyArray[j];found=value;for(var i=0;i<cleaned.length;i++){if(this.compare(cleaned[i],value)){found=null;}}
if(found){cleaned.push(found);}}
return cleaned;};this.compare=function(array1,array2){if(!array1||!array2){return false;}
if(array1.length!=array2.length){return false;}
for(var i=0;i<array1.length;i++){if(this[i]instanceof Array&&array2[i]instanceof Array){if(!this.compare(array1[i],array2[i])){return false;}}
else if(array1[i]!=array2[i]){return false;}}
return true;};this.diff=function(array1,array2){var diffData=[];diffData=populateDiffArray(array1,diffData);diffData=populateDiffArray(array2,diffData);var diffResult=[];for(var i=0;i<diffData.length;i++){if(diffData[i].count<=1){diffResult.push(diffData[i].item);}}
return diffResult;};};ig.arrayUtils=new PluginArrayUtils();});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/plugins/midas/ajaxpromise.js
ig.baked=true;ig.module('plugins.midas.ajaxpromise').requires('impact.impact','plugins.midas.arrayutils').defines(function(){PluginAjaxPromise=ig.Class.extend({doneCallbacks:[],failureCallbacks:[],alwaysCallbacks:[],result:null,state:0,setResult:function(result){this.result=result;},resolve:function(){this.state=PluginAjaxPromise.STATE.FULFILLED;this.isDone();this.isAlways();},reject:function(){this.state=PluginAjaxPromise.STATE.FAILED;this.isFailure();this.isAlways();},operateOnDelegates:function(callbackCollection){ig.arrayUtils.each(callbackCollection,function(value){value(this.result);},this);},isDone:function(){this.operateOnDelegates(this.doneCallbacks);},isFailure:function(){this.operateOnDelegates(this.failureCallbacks);},isAlways:function(){this.operateOnDelegates(this.alwaysCallbacks);},done:function(newDoneCallback){if(this.state==PluginAjaxPromise.STATE.FULFILLED){newDoneCallback(this.result);}else{this.doneCallbacks.push(newDoneCallback);}},fail:function(newFailCallback){if(this.state==PluginAjaxPromise.STATE.FAILED){newFailCallback(this.result);}else{this.failureCallbacks.push(newFailCallback);}},always:function(newAlwaysCallback){if(this.state==PluginAjaxPromise.STATE.UNFULFILLED){this.alwaysCallbacks.push(newAlwaysCallback);}else{newAlwaysCallback(this.result);}}});PluginAjaxPromise.STATE={UNFULFILLED:0,FULFILLED:1,FAILED:2};});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/plugins/midas/ajax.js
ig.baked=true;ig.module('plugins.midas.ajax').requires('impact.impact','plugins.midas.ajaxpromise').defines(function(){PluginAjax=ig.Class.extend({get:function(url){var promise=new PluginAjaxPromise();var request=null;if(window.XMLHttpRequest){request=new XMLHttpRequest();}else{request=new ActiveXObject("Microsoft.XMLHTTP");}
request.onreadystatechange=function(){if(request.readyState==4){if(request.status==200){promise.setResult(request);promise.resolve();}else{promise.reject();}}};request.open('GET',url,true);request.send();return promise;},getJson:function(url){var promise=new PluginAjaxPromise();var request=null;if(window.XMLHttpRequest){request=new XMLHttpRequest();}else{request=new ActiveXObject("Microsoft.XMLHTTP");}
request.onreadystatechange=function(){if(request.readyState==4){if(request.status==200){promise.setResult(JSON.parse(request.response));promise.resolve();}else{promise.setResult({});promise.reject();}}};request.open('GET',url,true);request.send();return promise;},post:function(url,data){var promise=new PluginAjaxPromise();var request=null;if(window.XMLHttpRequest){request=new XMLHttpRequest();}else{request=new ActiveXObject("Microsoft.XMLHTTP");}
request.onreadystatechange=function(){if(request.readyState==4){if(request.status==200){promise.setResult(request);promise.resolve();}else{promise.reject();}}};request.open('POST',url,true);request.send(this.dataToParams(data));return promise;},postJson:function(url,data){var promise=new PluginAjaxPromise();var request=null;if(window.XMLHttpRequest){request=new XMLHttpRequest();}else{request=new ActiveXObject("Microsoft.XMLHTTP");}
request.onreadystatechange=function(){if(request.readyState==4){if(request.status==200){promise.setResult(JSON.parse(request.response));promise.resolve();}else{promise.reject();}}};request.open('POST',url,true);request.send(this.dataToParams(data));return promise;},dataToParams:function(data){var paramArray=[];for(var key in data){if(data.hasOwnProperty(key)){var value=data[key];if(typeof value==='object'){value=JSON.stringify(value);}
paramArray.push(key+"="+value);}}
return paramArray.join("&");}});ig.ajax=new PluginAjax();});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/launcher/ui/nextgameinfopanel.js
ig.baked=true;ig.module('launcher.ui.nextgameinfopanel').requires('impact.entity','plugins.midas.draw').defines(function(){NextGameInfoPanel=ig.Entity.extend({size:{x:600,y:400},headerFont:new ig.Font(pmGameData.assetPath+'common/opensans-48-800-gray.font.png'),scoreFont:new ig.Font(pmGameData.assetPath+'common/opensans-60-gray.font.png'),scoreLabelFont:new ig.Font(pmGameData.assetPath+'common/opensans-24-lightgray.font.png'),labelFont:new ig.Font(pmGameData.assetPath+'common/opensans-24-600-gray.font.png'),gameIcon:new ig.AnimationSheet(pmGameData.gameIcon,108,108),gameIconAnimation:null,init:function(x,y,settings){this.parent(x,y,settings);this.gameIconAnimation=new ig.Animation(this.gameIcon,1,[ig.global['nextGame'].gameIconIndex]);},update:function(){},draw:function(){var x=this.pos.x+(this.size.x/2),y=this.pos.y+(this.size.y/2);ig.draw.setStroke(null);ig.draw.setFill("#F9F9F9");ig.draw.rect(this.pos.x,this.pos.y,this.size.x,this.size.y);ig.draw.setFill(null);ig.draw.setStroke(pmGameData.backgroundColor);ig.draw.setLineWidth(4);ig.draw.rect(this.pos.x+10,this.pos.y+10,this.size.x-20,this.size.y-20);ig.draw.setStroke("#D3D3D3");ig.draw.line(this.pos.x+50,this.pos.y+100,this.pos.x+this.size.x-50,this.pos.y+100);ig.draw.line(this.pos.x+50,this.pos.y+190,this.pos.x+this.size.x-50,this.pos.y+190);this.headerFont.draw('CONGRATULATIONS!',x,y-160,ig.Font.ALIGN.CENTER);this.scoreLabelFont.draw('YOUR\nSCORE',x-30,y-80,ig.Font.ALIGN.RIGHT);this.scoreFont.draw(ig.global['headerui'].prettyPrintScore(ig.global['score']),x-20,y-100,ig.Font.ALIGN.LEFT);this.labelFont.draw("NEXT UP: "+ig.global['nextGame'].name,x,y,ig.Font.ALIGN.CENTER);this.gameIconAnimation.draw(x-54,y-54+90);this.parent();}});});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/launcher/ui/playagaininfopanel.js
ig.baked=true;ig.module('launcher.ui.playagaininfopanel').requires('impact.entity','plugins.midas.draw').defines(function(){PlayAgainInfoPanel=ig.Entity.extend({size:{x:600,y:400},headerFont:new ig.Font(pmGameData.assetPath+'common/opensans-48-800-gray.font.png'),scoreFont:new ig.Font(pmGameData.assetPath+'common/opensans-60-gray.font.png'),scoreLabelFont:new ig.Font(pmGameData.assetPath+'common/opensans-24-lightgray.font.png'),labelFont:new ig.Font(pmGameData.assetPath+'common/opensans-24-600-gray.font.png'),gameIcon:new ig.AnimationSheet(pmGameData.gameIcon,108,108),gameIconAnimation:null,init:function(x,y,settings){this.parent(x,y,settings);this.gameIconAnimation=new ig.Animation(this.gameIcon,1,[ig.global['nextGame'].gameIconIndex]);},update:function(){},draw:function(){var x=this.pos.x+(this.size.x/2),y=this.pos.y+(this.size.y/2);ig.draw.setStroke(null);ig.draw.setFill("#F9F9F9");ig.draw.rect(this.pos.x,this.pos.y,this.size.x,this.size.y);ig.draw.setFill(null);ig.draw.setStroke(pmGameData.backgroundColor);ig.draw.setLineWidth(4);ig.draw.rect(this.pos.x+10,this.pos.y+10,this.size.x-20,this.size.y-20);ig.draw.setStroke("#D3D3D3");ig.draw.line(this.pos.x+50,this.pos.y+100,this.pos.x+this.size.x-50,this.pos.y+100);ig.draw.line(this.pos.x+50,this.pos.y+190,this.pos.x+this.size.x-50,this.pos.y+190);this.headerFont.draw('CONGRATULATIONS!',x,y-160,ig.Font.ALIGN.CENTER);this.scoreLabelFont.draw('YOUR\nSCORE',x-30,y-80,ig.Font.ALIGN.RIGHT);this.scoreFont.draw(ig.global['headerui'].prettyPrintScore(ig.global['score']),x-20,y-100,ig.Font.ALIGN.LEFT);this.labelFont.draw("Currently playing:",x,y-5,ig.Font.ALIGN.CENTER);this.gameIconAnimation.draw(x-54,y-54+80);this.labelFont.draw(pmGameData.displayName,x,y+135,ig.Font.ALIGN.CENTER);this.parent();}});});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/launcher/ui/lessoncompleteinfopanel.js
ig.baked=true;ig.module('launcher.ui.lessoncompleteinfopanel').requires('impact.entity','plugins.midas.draw').defines(function(){LessonCompleteInfoPanel=ig.Entity.extend({size:{x:600,y:400},headerFont:new ig.Font(pmGameData.assetPath+'common/opensans-48-800-gray.font.png'),scoreFont:new ig.Font(pmGameData.assetPath+'common/opensans-60-gray.font.png'),scoreLabelFont:new ig.Font(pmGameData.assetPath+'common/opensans-24-lightgray.font.png'),labelFont:new ig.Font(pmGameData.assetPath+'common/opensans-24-600-gray.font.png'),init:function(x,y,settings){this.parent(x,y,settings);},update:function(){},draw:function(){var x=this.pos.x+(this.size.x/2),y=this.pos.y+(this.size.y/2);ig.draw.setStroke(null);ig.draw.setFill("#F9F9F9");ig.draw.rect(this.pos.x,this.pos.y,this.size.x,this.size.y);ig.draw.setFill(null);ig.draw.setStroke(pmGameData.backgroundColor);ig.draw.setLineWidth(4);ig.draw.rect(this.pos.x+10,this.pos.y+10,this.size.x-20,this.size.y-20);ig.draw.setStroke("#D3D3D3");ig.draw.line(this.pos.x+50,this.pos.y+100,this.pos.x+this.size.x-50,this.pos.y+100);ig.draw.line(this.pos.x+50,this.pos.y+190,this.pos.x+this.size.x-50,this.pos.y+190);this.headerFont.draw('CONGRATULATIONS!',x,y-160,ig.Font.ALIGN.CENTER);this.scoreLabelFont.draw('You\'ve finished '+ig.global['nextGame'].currentName+'!',x,y-65,ig.Font.ALIGN.CENTER);this.labelFont.draw('START '+ig.global['nextGame'].nextName,x,y+20,ig.Font.ALIGN.CENTER);this.parent();}});});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/launcher/ui/trainingcompleteinfopanel.js
ig.baked=true;ig.module('launcher.ui.trainingcompleteinfopanel').requires('impact.entity','plugins.midas.draw').defines(function(){TrainingCompleteInfoPanel=ig.Entity.extend({size:{x:600,y:400},headerFont:new ig.Font(pmGameData.assetPath+'common/opensans-48-800-gray.font.png'),scoreFont:new ig.Font(pmGameData.assetPath+'common/opensans-60-gray.font.png'),scoreLabelFont:new ig.Font(pmGameData.assetPath+'common/opensans-24-lightgray.font.png'),labelFont:new ig.Font(pmGameData.assetPath+'common/opensans-24-600-gray.font.png'),brainSpritesheet:new ig.AnimationSheet(pmGameData.assetPath+'common/brains.png',123,108),brains:{},init:function(x,y,settings){this.parent(x,y,settings);this.brains['gold']=new ig.Animation(this.brainSpritesheet,1,[0]);this.brains['silver']=new ig.Animation(this.brainSpritesheet,1,[1]);this.brains['bronze']=new ig.Animation(this.brainSpritesheet,1,[2]);},update:function(){this.brains[ig.global['nextGame'].currentBrain.toLowerCase()].update();},draw:function(){var x=this.pos.x+(this.size.x/2),y=this.pos.y+(this.size.y/2);ig.draw.setStroke(null);ig.draw.setFill("#F9F9F9");ig.draw.rect(this.pos.x,this.pos.y,this.size.x,this.size.y);ig.draw.setFill(null);ig.draw.setStroke(pmGameData.backgroundColor);ig.draw.setLineWidth(4);ig.draw.rect(this.pos.x+10,this.pos.y+10,this.size.x-20,this.size.y-20);ig.draw.setStroke("#D3D3D3");ig.draw.line(this.pos.x+50,this.pos.y+100,this.pos.x+this.size.x-50,this.pos.y+100);ig.draw.line(this.pos.x+50,this.pos.y+300,this.pos.x+this.size.x-50,this.pos.y+300);this.headerFont.draw('CONGRATULATIONS!',x,y-160,ig.Font.ALIGN.CENTER);this.scoreLabelFont.draw('You\'ve completed '+ig.global['nextGame'].name+'!',x,y-85,ig.Font.ALIGN.CENTER);this.labelFont.draw('TOTAL POINTS: '+ig.global['nextGame'].totalPoints+'!',x,y-55,ig.Font.ALIGN.CENTER);this.labelFont.draw('CURRENT BRAIN: '+ig.global['nextGame'].currentBrain,x,y+120,ig.Font.ALIGN.CENTER);this.brains[ig.global['nextGame'].currentBrain.toLowerCase()].draw(x-60,y-25);this.parent();}});});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/plugins/midas/drawnbutton.js
ig.baked=true;ig.module('plugins.midas.drawnbutton').requires('impact.entity','plugins.midas.draw').defines(function(){EntityDrawnButton=ig.Entity.extend({size:{x:80,y:40},state:'idle',wasPreviouslyPressed:false,wasPreviouslyHovered:false,text:"Submit",font:null,fillColors:{idle:"#FF0000",hover:"#FF8888",active:"#FF8888"},strokeColors:{idle:null,hover:null,active:null},buttonFillColor:"#FF0000",buttonStrokeColor:null,init:function(x,y,settings){this.parent(x,y,settings);},update:function(){if(this.state=='hidden'){return;}
if(this.font!=null){this.font.alpha=1;if(this.size.x<this.font.widthForString(this.text)){this.size.x=this.font.widthForString(this.text);}
if(this.size.y<this.font.heightForString(this.text)){this.size.y=this.font.heightForString(this.text);}}
var isClicked=ig.input.state('click');if(this.mouseWithinButton()){this.wasPreviouslyHovered=true;document.body.style.cursor="pointer";if(isClicked){this.setState('active');if(this.wasPreviouslyPressed){this.pressed();}else{this.onPress();}
this.wasPreviouslyPressed=true;}else{this.setState('hover');if(this.wasPreviouslyPressed){document.body.style.cursor="default";this.onRelease();}
this.wasPreviouslyPressed=false;}}else{if(this.wasPreviouslyHovered){document.body.style.cursor="default";this.setState('idle');this.wasPreviouslyPressed=false;}}},draw:function(){if(this.state=='hidden'){return;}
ig.draw.setStroke(this.strokeColors[this.state]);ig.draw.setFill(this.fillColors[this.state]);ig.draw.rect(this.pos.x,this.pos.y,this.size.x,this.size.y);if(this.font!=null){this.font.draw(this.text,this.pos.x+this.size.x/2,this.pos.y+this.size.y/2-this.font.heightForString(this.text)/2,ig.Font.ALIGN.CENTER);}
this.parent();},setState:function(s){this.state=s;},onPress:function(){},pressed:function(){},onRelease:function(){},mouseWithinButton:function(){return ig.input.mouse.x+ig.game.screen.x>this.pos.x&&ig.input.mouse.x+ig.game.screen.x<this.pos.x+this.size.x&&ig.input.mouse.y+ig.game.screen.y>this.pos.y&&ig.input.mouse.y+ig.game.screen.y<this.pos.y+this.size.y;}});});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/launcher/endgame.js
ig.baked=true;ig.module('launcher.endgame').requires('impact.game','impact.font','launcher.ui.nextgameinfopanel','launcher.ui.playagaininfopanel','launcher.ui.lessoncompleteinfopanel','launcher.ui.trainingcompleteinfopanel','plugins.midas.button','plugins.midas.drawnbutton','plugins.midas.draw').defines(function(){EndGame=ig.Game.extend({clearColor:pmGameData.backgroundColor,headerFont:new ig.Font(pmGameData.assetPath+'common/opensans-48-gray.font.png'),scoreFont:new ig.Font(pmGameData.assetPath+'common/opensans-60-gray.font.png'),labelFont:new ig.Font(pmGameData.assetPath+'common/opensans-24-lightgray.font.png'),buttonClick:new ig.Sound(pmGameData.assetPath+'common/button-click.*'),init:function(){document.body.style.cursor="default";ig.input.bind(ig.KEY.MOUSE1,'click');if(ig.global['nextGame'].type=="nextGame"){this.nextGame();}else if(ig.global['nextGame'].type=="nextLesson"){this.lessonComplete();}else if(ig.global['nextGame'].type=="trainingComplete"){this.trainingComplete();}else if(ig.global['nextGame'].type=="playAgain"){this.playAgain();}},nextGame:function(){var x=ig.system.width/2,y=ig.system.height/2;ig.game.spawnEntity(NextGameInfoPanel,100,100,{});ig.game.spawnEntity(EntityDrawnButton,x-125,y+165,{font:new ig.Font(pmGameData.assetPath+'common/dosis-30-white.font.png'),size:{x:250,y:60},text:"PLAY NOW!",fillColors:{idle:pmGameData.complementColor,hover:pmGameData.complementHighlightColor,active:pmGameData.complementHighlightColor},strokeColors:{idle:null,hover:null,active:null},onRelease:function(){ig.game.buttonClick.play();var url=ig.global['nextGame'].url;if(url!=""&&url!=null){document.location.href=url;}else{ig.global["wrapperState"]="starting";ig.system.setGame(GameWrapper);}}});},playAgain:function(){pmGameData.id=ig.global['nextGame'].id;var x=ig.system.width/2,y=ig.system.height/2;ig.game.spawnEntity(PlayAgainInfoPanel,100,100,{});ig.game.spawnEntity(EntityDrawnButton,x-125,y+165,{font:new ig.Font(pmGameData.assetPath+'common/dosis-30-white.font.png'),size:{x:250,y:60},text:"PLAY AGAIN?",fillColors:{idle:pmGameData.complementColor,hover:pmGameData.complementHighlightColor,active:pmGameData.complementHighlightColor},strokeColors:{idle:null,hover:null,active:null},onRelease:function(){ig.game.buttonClick.play();var url=ig.global['nextGame'].url;if(ig.global['nextGame'].type=="playAgain"||url==""||url==null){ig.global["wrapperState"]="starting";ig.system.setGame(GameWrapper);}else{document.location.href=url;}}});},lessonComplete:function(){var x=ig.system.width/2,y=ig.system.height/2;ig.game.spawnEntity(LessonCompleteInfoPanel,100,100,{});ig.game.spawnEntity(EntityDrawnButton,x-125,y+85,{font:new ig.Font(pmGameData.assetPath+'common/dosis-30-white.font.png'),size:{x:250,y:60},text:"NEXT WORKOUT!",fillColors:{idle:pmGameData.complementColor,hover:pmGameData.complementHighlightColor,active:pmGameData.complementHighlightColor},strokeColors:{idle:null,hover:null,active:null},onRelease:function(){ig.game.buttonClick.play();var url=ig.global['nextGame'].url;if(url!=""&&url!=null){document.location.href=url;}else{ig.global["wrapperState"]="starting";ig.system.setGame(GameWrapper);}}});},trainingComplete:function(){var x=ig.system.width/2,y=ig.system.height/2;ig.game.spawnEntity(TrainingCompleteInfoPanel,100,100,{});ig.game.spawnEntity(EntityDrawnButton,x-125,y+165,{font:new ig.Font(pmGameData.assetPath+'common/dosis-30-white.font.png'),size:{x:250,y:60},text:"MORE TRAINING!",fillColors:{idle:pmGameData.complementColor,hover:pmGameData.complementHighlightColor,active:pmGameData.complementHighlightColor},strokeColors:{idle:null,hover:null,active:null},onRelease:function(){ig.game.buttonClick.play();var url=ig.global['nextGame'].url;if(url!=""&&url!=null){document.location.href=url;}else{ig.global["wrapperState"]="starting";ig.system.setGame(GameWrapper);}}});},update:function(){this.parent();ig.global['headerui'].update();},draw:function(){this.parent();ig.global['headerui'].draw();}});});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/plugins/midas/imageasset.js
ig.baked=true;ig.module('plugins.midas.imageasset').requires('impact.image').defines(function(){ImageAsset=ig.Image.extend({asyncLoaded:false,init:function(asyncImage){if(asyncImage){this.data=asyncImage;this.width=asyncImage.width;this.height=asyncImage.height;this.loaded=true;this.asyncLoaded=true;if(ig.system.scale!=1){this.resize(ig.system.scale);}}}});});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/plugins/midas/imageloader.js
ig.baked=true;ig.module('plugins.midas.imageloader').requires('impact.impact','plugins.midas.imageasset','plugins.midas.ajaxpromise').defines(function(){PluginImageLoader=ig.Class.extend({getImage:function(path){var promise=new PluginAjaxPromise();if(path==null||path==""){promise.reject();return promise;}
var asyncImage=new Image();asyncImage.onload=function(event){promise.setResult(asyncImage);promise.resolve();};asyncImage.onerror=function(event){promise.setResult(asyncImage);promise.reject();};asyncImage.src=path;return promise;},loadImage:function(path,imageAsset){var promise=this.getImage(path);promise.done(function(result){imageAsset.init(result);});return promise;}});});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/plugins/tween.js
ig.baked=true;ig.module('plugins.tween').requires('impact.entity').defines(function(){if(!Array.prototype.indexOf){Array.prototype.indexOf=function(el,start){var start=start||0;for(var i=0;i<this.length;++i){if(this[i]===el){return i;}}
return-1;};}
ig.Entity.prototype.tweens=[];ig.Entity.prototype._preTweenUpdate=ig.Entity.prototype.update;ig.Entity.prototype.update=function(){this._preTweenUpdate();if(this.tweens.length>0){var currentTweens=[];for(var i=0;i<this.tweens.length;i++){this.tweens[i].update();if(!this.tweens[i].complete)currentTweens.push(this.tweens[i]);}
this.tweens=currentTweens;}};ig.Entity.prototype.tween=function(props,duration,settings){var tween=new ig.Tween(this,props,duration,settings);this.tweens.push(tween);return tween;};ig.Entity.prototype.pauseTweens=function(){for(var i=0;i<this.tweens.length;i++){this.tweens[i].pause();}};ig.Entity.prototype.resumeTweens=function(){for(var i=0;i<this.tweens.length;i++){this.tweens[i].resume();}};ig.Entity.prototype.stopTweens=function(doComplete){for(var i=0;i<this.tweens.length;i++){this.tweens[i].stop(doComplete);}};ig.Tween=function(obj,properties,duration,settings){var _object=obj;var valuesStart={};var valuesEnd={};var valuesDelta={};var _elapsed=0;var timer=false;var started=false;var _props=properties;var _chained=false;this.duration=duration;this.complete=false;this.paused=false;this.easing=ig.Tween.Easing.Linear.EaseNone;this.onComplete=false;this.delay=0;this.loop=0;this.loopCount=-1;ig.merge(this,settings);this.loopNum=this.loopCount;this.chain=function(chainObj){_chained=chainObj;};this.initEnd=function(prop,from,to){if(typeof(from[prop])!=="object"){to[prop]=from[prop];}else{for(subprop in from[prop]){if(!to[prop])to[prop]={};this.initEnd(subprop,from[prop],to[prop]);}}};this.initStart=function(prop,end,from,to){if(typeof(from[prop])!=="object"){if(typeof(end[prop])!=="undefined")to[prop]=from[prop];}else{for(subprop in from[prop]){if(!to[prop])to[prop]={};if(typeof(end[prop])!=="undefined")this.initStart(subprop,end[prop],from[prop],to[prop]);}}};this.start=function(){this.complete=false;this.paused=false;this.loopNum=this.loopCount;_elapsed=0;if(_object.tweens.indexOf(this)==-1)_object.tweens.push(this);started=true;timer=new ig.Timer();for(var property in _props){this.initEnd(property,_props,valuesEnd);}
for(var property in valuesEnd){this.initStart(property,valuesEnd,_object,valuesStart);this.initDelta(property,valuesDelta,_object,valuesEnd);}};this.initDelta=function(prop,delta,start,end){if(typeof(end[prop])!=="object"){delta[prop]=end[prop]-start[prop];}else{for(subprop in end[prop]){if(!delta[prop])delta[prop]={};this.initDelta(subprop,delta[prop],start[prop],end[prop]);}}};this.propUpdate=function(prop,obj,start,delta,value){if(typeof(start[prop])!=="object"){if(typeof start[prop]!="undefined"){obj[prop]=start[prop]+delta[prop]*value;}else{obj[prop]=obj[prop];}}else{for(subprop in start[prop]){this.propUpdate(subprop,obj[prop],start[prop],delta[prop],value);}}};this.propSet=function(prop,from,to){if(typeof(from[prop])!=="object"){to[prop]=from[prop];}else{for(subprop in from[prop]){if(!to[prop])to[prop]={};this.propSet(subprop,from[prop],to[prop]);}}};this.update=function(){if(!started)return false;if(this.delay){if(timer.delta()<this.delay)return;this.delay=0;timer.reset();}
if(this.paused||this.complete)return false;var elapsed=(timer.delta()+_elapsed)/this.duration;elapsed=elapsed>1?1:elapsed;var value=this.easing(elapsed);for(property in valuesDelta){this.propUpdate(property,_object,valuesStart,valuesDelta,value);}
if(elapsed>=1){if(this.loopNum==0||!this.loop){this.complete=true;if(this.onComplete)this.onComplete();if(_chained)_chained.start();return false;}else if(this.loop==ig.Tween.Loop.Revert){for(property in valuesStart){this.propSet(property,valuesStart,_object);}
_elapsed=0;timer.reset();if(this.loopNum!=-1)this.loopNum--;}else if(this.loop==ig.Tween.Loop.Reverse){var _start={},_end={},_delta={};ig.merge(_start,valuesEnd);ig.merge(_end,valuesStart);ig.merge(valuesStart,_start);ig.merge(valuesEnd,_end);for(property in valuesEnd){this.initDelta(property,valuesDelta,_object,valuesEnd);}
_elapsed=0;timer.reset();if(this.loopNum!=-1)this.loopNum--;}}};this.pause=function(){this.paused=true;_elapsed+=timer.delta();};this.resume=function(){this.paused=false;timer.reset();};this.stop=function(doComplete){if(doComplete){this.paused=false;this.complete=false;this.loop=false;_elapsed+=duration;this.update();}
this.complete=true;}};ig.Tween.Loop={Revert:1,Reverse:2};ig.Tween.Easing={Linear:{},Quadratic:{},Cubic:{},Quartic:{},Quintic:{},Sinusoidal:{},Exponential:{},Circular:{},Elastic:{},Back:{},Bounce:{}};ig.Tween.Easing.Linear.EaseNone=function(k){return k;};ig.Tween.Easing.Quadratic.EaseIn=function(k){return k*k;};ig.Tween.Easing.Quadratic.EaseOut=function(k){return-k*(k-2);};ig.Tween.Easing.Quadratic.EaseInOut=function(k){if((k*=2)<1)return 0.5*k*k;return-0.5*(--k*(k-2)-1);};ig.Tween.Easing.Cubic.EaseIn=function(k){return k*k*k;};ig.Tween.Easing.Cubic.EaseOut=function(k){return--k*k*k+1;};ig.Tween.Easing.Cubic.EaseInOut=function(k){if((k*=2)<1)return 0.5*k*k*k;return 0.5*((k-=2)*k*k+2);};ig.Tween.Easing.Quartic.EaseIn=function(k){return k*k*k*k;};ig.Tween.Easing.Quartic.EaseOut=function(k){return-(--k*k*k*k-1);}
ig.Tween.Easing.Quartic.EaseInOut=function(k){if((k*=2)<1)return 0.5*k*k*k*k;return-0.5*((k-=2)*k*k*k-2);};ig.Tween.Easing.Quintic.EaseIn=function(k){return k*k*k*k*k;};ig.Tween.Easing.Quintic.EaseOut=function(k){return(k=k-1)*k*k*k*k+1;};ig.Tween.Easing.Quintic.EaseInOut=function(k){if((k*=2)<1)return 0.5*k*k*k*k*k;return 0.5*((k-=2)*k*k*k*k+2);};ig.Tween.Easing.Sinusoidal.EaseIn=function(k){return-Math.cos(k*Math.PI/2)+1;};ig.Tween.Easing.Sinusoidal.EaseOut=function(k){return Math.sin(k*Math.PI/2);};ig.Tween.Easing.Sinusoidal.EaseInOut=function(k){return-0.5*(Math.cos(Math.PI*k)-1);};ig.Tween.Easing.Exponential.EaseIn=function(k){return k==0?0:Math.pow(2,10*(k-1));};ig.Tween.Easing.Exponential.EaseOut=function(k){return k==1?1:-Math.pow(2,-10*k)+1;};ig.Tween.Easing.Exponential.EaseInOut=function(k){if(k==0)return 0;if(k==1)return 1;if((k*=2)<1)return 0.5*Math.pow(2,10*(k-1));return 0.5*(-Math.pow(2,-10*(k-1))+2);};ig.Tween.Easing.Circular.EaseIn=function(k){return-(Math.sqrt(1-k*k)-1);};ig.Tween.Easing.Circular.EaseOut=function(k){return Math.sqrt(1-(--k*k));};ig.Tween.Easing.Circular.EaseInOut=function(k){if((k/=0.5)<1)return-0.5*(Math.sqrt(1-k*k)-1);return 0.5*(Math.sqrt(1-(k-=2)*k)+1);};ig.Tween.Easing.Elastic.EaseIn=function(k){var s,a=0.1,p=0.4;if(k==0)return 0;if(k==1)return 1;if(!p)p=0.3;if(!a||a<1){a=1;s=p/4;}
else s=p/(2*Math.PI)*Math.asin(1/a);return-(a*Math.pow(2,10*(k-=1))*Math.sin((k-s)*(2*Math.PI)/p));};ig.Tween.Easing.Elastic.EaseOut=function(k){var s,a=0.1,p=0.4;if(k==0)return 0;if(k==1)return 1;if(!p)p=0.3;if(!a||a<1){a=1;s=p/4;}
else s=p/(2*Math.PI)*Math.asin(1/a);return(a*Math.pow(2,-10*k)*Math.sin((k-s)*(2*Math.PI)/p)+1);};ig.Tween.Easing.Elastic.EaseInOut=function(k){var s,a=0.1,p=0.4;if(k==0)return 0;if(k==1)return 1;if(!p)p=0.3;if(!a||a<1){a=1;s=p/4;}
else s=p/(2*Math.PI)*Math.asin(1/a);if((k*=2)<1)return-0.5*(a*Math.pow(2,10*(k-=1))*Math.sin((k-s)*(2*Math.PI)/p));return a*Math.pow(2,-10*(k-=1))*Math.sin((k-s)*(2*Math.PI)/p)*0.5+1;};ig.Tween.Easing.Back.EaseIn=function(k){var s=1.70158;return k*k*((s+1)*k-s);};ig.Tween.Easing.Back.EaseOut=function(k){var s=1.70158;return(k=k-1)*k*((s+1)*k+s)+1;};ig.Tween.Easing.Back.EaseInOut=function(k){var s=1.70158*1.525;if((k*=2)<1)return 0.5*(k*k*((s+1)*k-s));return 0.5*((k-=2)*k*((s+1)*k+s)+2);};ig.Tween.Easing.Bounce.EaseIn=function(k){return 1-ig.Tween.Easing.Bounce.EaseOut(1-k);};ig.Tween.Easing.Bounce.EaseOut=function(k){if((k/=1)<(1/2.75)){return 7.5625*k*k;}else if(k<(2/2.75)){return 7.5625*(k-=(1.5/2.75))*k+0.75;}else if(k<(2.5/2.75)){return 7.5625*(k-=(2.25/2.75))*k+0.9375;}else{return 7.5625*(k-=(2.625/2.75))*k+0.984375;}};ig.Tween.Easing.Bounce.EaseInOut=function(k){if(k<0.5)return ig.Tween.Easing.Bounce.EaseIn(k*2)*0.5;return ig.Tween.Easing.Bounce.EaseOut(k*2-1)*0.5+0.5;};});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/com/purelymental/memory/entities/tile.js
ig.baked=true;ig.module('com.purelymental.memory.entities.tile').requires('impact.entity','impact.sound','plugins.midas.imageasset','plugins.midas.imageloader','plugins.tween').defines(function(){EntityTile=ig.Entity.extend({animSheet:new ig.AnimationSheet(pmGameData.assetPath+'memory/memory_tiles.png',105,105),cardObjects:new ig.Image(pmGameData.assetPath+'memory/animals.png'),size:{x:105,y:105},friendImage:null,state:"facedown",symbol:0,delayTimer:new ig.Timer(),board:null,tilePos:{x:0,y:0},clickSound:new ig.Sound(pmGameData.assetPath+"common/click.*"),init:function(x,y,settings){this.parent(x,y,settings);this.addAnim('facedown',1,[0]);this.addAnim('faceup',1,[1]);this.addAnim('correct',1,[2]);this.addAnim('incorrect',1,[3]);this.addAnim('removed',1,[4]);var self=this;this.friendImage=new ImageAsset();this.imageLoader=new PluginImageLoader();var promise=this.imageLoader.loadImage(this.friendUrl,this.friendImage);promise.always(function(result){self.tween({pos:{y:self.tilePos.y}},Math.random()*0.4+0.5,{easing:ig.Tween.Easing.Elastic.EaseOut,onComplete:function(){self.board.tilesLoaded++;}}).start();});},withinBounds:function(){return ig.input.mouse.x+ig.game.screen.x>this.pos.x&&ig.input.mouse.x+ig.game.screen.x<this.pos.x+this.size.x&&ig.input.mouse.y+ig.game.screen.y>this.pos.y&&ig.input.mouse.y+ig.game.screen.y<this.pos.y+this.size.y;},update:function(){if(this.withinBounds()){document.body.style.cursor="pointer";if(ig.input.pressed('click')){this.clickSound.play();if(this.state=="facedown"){this.currentAnim=this.anims.faceup;this.state="faceup";}else if(this.state=="faceup"){this.currentAnim=this.anims.facedown;this.state="facedown";}}}
if(this.state=="correct"&&this.delayTimer.delta()>=1){this.state="removed";this.currentAnim=this.anims.removed;}
if(this.state=="incorrect"&&this.delayTimer.delta()>=1){this.state="facedown";this.currentAnim=this.anims.facedown;}
this.parent();},draw:function(){this.parent();var tileMiddleX=this.size.x/2+this.pos.x;var tileMiddleY=this.size.y/2+this.pos.y;if(this.state=="faceup"||this.state=="correct"||this.state=="incorrect"){if(this.friendImage.asyncLoaded){this.friendImage.draw(tileMiddleX-(this.friendImage.width/2),tileMiddleY-(this.friendImage.height/2));}else{this.cardObjects.drawTile(tileMiddleX-32,tileMiddleY-32,this.symbol,64);}}},validMatch:function(){this.currentAnim=this.anims.correct;this.state="correct";this.delayTimer.set(0);},invalidMatch:function(){this.currentAnim=this.anims.incorrect;this.state="incorrect";this.delayTimer.set(0);}});});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/com/purelymental/memory/entities/tileboard.js
ig.baked=true;ig.module('com.purelymental.memory.entities.tileboard').requires('impact.entity','impact.sound','com.purelymental.memory.entities.tile','plugins.midas.imageasset','plugins.midas.imageloader','plugins.midas.arrayutils','plugins.midas.ajax','plugins.midas.ajaxpromise','plugins.tween').defines(function(){EntityTileboard=ig.Entity.extend({size:{x:720,y:480},numberOfSymbols:0,wasClicked:false,tileSpacing:120,maxTiles:{x:6,y:2},isLoaded:false,tilesLoaded:0,incorrectSound:new ig.Sound(pmGameData.assetPath+"common/incorrect.*"),correctSound:new ig.Sound(pmGameData.assetPath+"common/correct.*"),init:function(x,y,settings){this.parent(x,y,settings);this.flippedCards=[];var symbolSet=[];var symbolOffset=Math.floor(Math.random()*(66-this.numberOfSymbols));for(var i=0;i<this.numberOfSymbols;i++){symbolSet.push(symbolOffset+i);symbolSet.push(symbolOffset+i);}
symbolSet=ig.arrayUtils.shuffle(symbolSet);if(symbolSet.length<=4){this.maxTiles.x=2;this.maxTiles.y=2;}else if(symbolSet.length<=6){this.maxTiles.x=3;this.maxTiles.y=2;}else if(symbolSet.length<=8){this.maxTiles.x=4;this.maxTiles.y=2;}else if(symbolSet.length<=10){this.maxTiles.x=5;this.maxTiles.y=2;}else if(symbolSet.length<=16){this.maxTiles.x=4;this.maxTiles.y=4;}else if(symbolSet.length<=20){this.maxTiles.x=5;this.maxTiles.y=4;}else if(symbolSet.length<=24){this.maxTiles.x=6;this.maxTiles.y=4;}
this.size.x=this.tileSpacing*this.maxTiles.x;this.size.y=this.tileSpacing*this.maxTiles.y;var facebookImageUrls=[];var promise=ig.ajax.getJson('/api/facebook/friendicons/'+this.numberOfSymbols+'/80/80');var board=this;promise.done(function(result){facebookImageUrls=[];var iconArray=result.icons;for(var i=0;i<iconArray.length;i++){var iconData=iconArray[i];facebookImageUrls.push(iconData.icon);}});promise.always(function(result){board.tilesLoaded=0;board.isLoaded=true;var usedSymbols=[];var staticLength=symbolSet.length;for(i=0;i<staticLength;i++){var tilePos={x:board.pos.x,y:board.pos.y};tilePos.x+=(board.tileSpacing*(i%board.maxTiles.x));tilePos.y+=(board.tileSpacing*Math.floor(i/board.maxTiles.x));var singleElement=symbolSet.splice(0,1);var nextSymbol=singleElement[0];if(usedSymbols.indexOf(nextSymbol)==-1){usedSymbols.push(nextSymbol);}
var settings={symbol:nextSymbol};if(usedSymbols.indexOf(nextSymbol)!=-1){settings.friendUrl=facebookImageUrls[usedSymbols.indexOf(nextSymbol)];}
settings.board=board;settings.tilePos=tilePos;ig.game.spawnEntity(EntityTile,tilePos.x,tilePos.y-600,settings);}});this.pos.x=(ig.system.width-this.size.x)/2;this.pos.y=(ig.system.height-this.size.y)/2+(ig.global['headerui'].size.y/2);},update:function(){document.body.style.cursor="default";if(this.tilesLoaded==this.numberOfSymbols*2){this.tilesLoaded=0;ig.global['headerui'].startStopwatch();}
if(!this.isLoaded){return;}
var boardTiles=ig.game.getEntitiesByType(EntityTile);var flippedTiles=[];var removedTiles=[];for(var i=0;i<boardTiles.length;i++){if(boardTiles[i].state=="faceup"){flippedTiles.push(boardTiles[i]);}else if(boardTiles[i].state=="removed"){removedTiles.push(boardTiles[i]);}}
if(flippedTiles.length==2){if(flippedTiles[0].symbol==flippedTiles[1].symbol){flippedTiles[0].validMatch();flippedTiles[1].validMatch();this.correctSound.play();ig.global['gameData'].correctMatch+=1;ig.global['headerui'].activateNextPip();ig.global['gameData'].timeDuration=ig.global['headerui'].getClock();}else{flippedTiles[0].invalidMatch();flippedTiles[1].invalidMatch();this.incorrectSound.play();ig.global['gameData'].incorrectMatch+=1;}}
if(this.numberOfSymbols==ig.global['gameData'].correctMatch){ig.global['headerui'].pauseStopwatch();}
if(removedTiles.length==this.numberOfSymbols*2){ig.game.win();}
this.parent();},draw:function(){this.parent();}});});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/com/purelymental/memory/game.js
ig.baked=true;ig.module('com.purelymental.memory.game').requires('impact.game','impact.timer','com.purelymental.memory.entities.tileboard','plugins.midas.arrayutils','plugins.midas.ajax','plugins.midas.ajaxpromise').defines(function(){Memory=ig.Game.extend({clearColor:pmGameData.backgroundColor,playTimer:null,board:null,numberOfSymbols:0,init:function(){ig.global['gameData'].incorrectMatch=0;ig.global['gameData'].timeDuration=0;ig.global['gameData'].correctMatch=0;ig.input.bind(ig.KEY.MOUSE1,'click');this.numberOfSymbols=ig.global['paramData'].num_tiles;ig.global['headerui'].enableStopwatch();ig.global['headerui'].enableLife();ig.global['headerui'].setPips(0,this.numberOfSymbols);this.board=this.spawnEntity(EntityTileboard,0,0,{numberOfSymbols:this.numberOfSymbols});},update:function(){this.parent();ig.global['headerui'].update();},win:function(){ig.global["wrapperState"]="ending";ig.system.setGame(GameWrapper);},draw:function(){this.parent();ig.global['headerui'].draw();}});});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/com/purelymental/memory/gamewrapper.js
ig.baked=true;ig.module('com.purelymental.memory.gamewrapper').requires('impact.game','plugins.midas.ajax','launcher.endgame','com.purelymental.memory.game').defines(function(){GameWrapper=ig.Game.extend({clearColor:pmGameData.backgroundColor,init:function(){if(ig.global["wrapperState"]=="starting"){this.start();ig.global["wrapperState"]="started";}
if(ig.global["wrapperState"]=="ending"){this.end();ig.global["wrapperState"]="ended";}},update:function(){this.parent();},draw:function(){this.parent();},start:function(){ig.global['gameData']={};var gameDataPromise=ig.ajax.postJson("/api/games/"+pmGameData.id+"/start.json",{});gameDataPromise.done(function(result){ig.global['paramData']=result.paramData;});gameDataPromise.fail(function(){ig.global['paramData']={num_tiles:3};});gameDataPromise.always(function(){ig.system.setGame(Memory);pmGameData.start();});},end:function(){var gameFinishPromise=ig.ajax.postJson("/api/games/"+pmGameData.id+"/finish.json",ig.global['gameData']);gameFinishPromise.done(function(result){ig.global['score']=result.score;ig.global['nextGame']=result.nextScreenData;});gameFinishPromise.fail(function(){var seconds=Math.floor(ig.global['gameData'].timeDuration/1000);var correctMinusError=ig.global['gameData'].correctMatch-ig.global['gameData'].incorrectMatch;ig.global['score']=Math.max(Math.floor((correctMinusError/(seconds+1))*1000),0);ig.global['nextGame']={type:"playAgain",url:null,gameIconIndex:pmGameData.gameIconIndex,id:pmGameData.id};});gameFinishPromise.always(function(){ig.system.setGame(EndGame);pmGameData.finish();});}});});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/com/purelymental/memory/howtoplay.js
ig.baked=true;ig.module('com.purelymental.memory.howtoplay').requires('impact.game','impact.font','impact.sound','plugins.midas.button').defines(function(){HowToPlay=ig.Game.extend({font:new ig.Font(pmGameData.assetPath+'common/proxima-extrabold-30-white.font.png'),clearColor:pmGameData.backgroundColor,buttonClick:new ig.Sound(pmGameData.assetPath+'common/button-click.*'),init:function(){ig.game.spawnEntity(EntityButton,650,450,{size:{x:128,y:128},animSheet:new ig.AnimationSheet(pmGameData.assetPath+'common/backbutton.png',128,128),onRelease:function(){ig.game.buttonClick.play();ig.system.setGame(MainMenu);}});},update:function(){this.parent();},draw:function(){this.parent();this.font.draw("Tiles is a game of memorization and speed.\n\nClick the tiles to reveal the picture\nunderneath, then click it's matching partner\nto remove the tile pair.\n\nYou win when all the tiles are removed,\nbut too many mistakes will cost you points.",50,50,ig.Font.ALIGN.LEFT);}});});

// /home/jgilman/git/purelymental-games/tools/../launcher/lib/launcher/mainmenu.js
ig.baked=true;ig.module('launcher.mainmenu').requires('impact.game','impact.font','impact.sound','launcher.ui.header','launcher.ui.credits','plugins.midas.button','plugins.midas.browserinfo','com.purelymental.'+pmGameData.includePath+'.gamewrapper','com.purelymental.'+pmGameData.includePath+'.howtoplay').defines(function(){MainMenu=ig.Game.extend({font:new ig.Font(pmGameData.assetPath+'common/proxima-extrabold-30-white.font.png'),gameIcon:new ig.AnimationSheet(pmGameData.gameIcon,108,108),clearColor:pmGameData.backgroundColor,gameIconAnimation:null,buttonClick:new ig.Sound(pmGameData.assetPath+'common/button-click.*'),init:function(){this.gameIconAnimation=new ig.Animation(this.gameIcon,1,[pmGameData.gameIconIndex]);ig.global['score']=0;ig.global['gameData']={};document.body.style.cursor="default";ig.global['headerui']=new HeaderUI();ig.input.bind(ig.KEY.MOUSE1,'click');var x=ig.system.width/2,y=ig.system.height/2;ig.game.spawnEntity(EntityButton,x+24,y+150,{size:{x:190,y:48},animSheet:new ig.AnimationSheet(pmGameData.assetPath+'common/btnstartgame.png',190,48),onRelease:function(){ig.game.buttonClick.play();ig.global["wrapperState"]="starting";ig.system.setGame(GameWrapper);}});ig.game.spawnEntity(EntityButton,x-214,y+150,{size:{x:190,y:48},animSheet:new ig.AnimationSheet(pmGameData.assetPath+'common/btnhowtoplay.png',190,48),onRelease:function(){ig.game.buttonClick.play();ig.system.setGame(HowToPlay);}});ig.game.spawnEntity(CreditsButton,4,580,{size:{x:16,y:16},animSheet:new ig.AnimationSheet('common/credits.png',16,16),onRelease:function(){ig.game.buttonClick.play();ig.system.setGame(Credits);}});},update:function(){this.parent();ig.global['headerui'].update();},draw:function(){this.parent();var x=ig.system.width/2,y=ig.system.height/2;this.gameIconAnimation.draw(x-54,y-54);this.font.draw(pmGameData.displayName,x,y-150,ig.Font.ALIGN.CENTER);ig.global['headerui'].draw();}});var browsers=[{name:"Safari",version:6}];ig.ua.safari=/safari/i.test(navigator.userAgent);if(ig.ua.mobile||ig.browserInfo.shouldBlock(browsers)){ig.Sound.enabled=false;}
ig.main('#canvas',MainMenu,60,800,600);});